;LAMA_KONSTANTEN
;---------------------------
;ALLGEMEIN
Const LAMA_Host%=1
Const LAMA_Client%=2
Const LAMA_FSend%=1
Const LAMA_FRecv%=2
;VERBINDUNG
Const LAMA_Connected%=101
Const LAMA_Hosted%=102
Const LAMA_Joined%=103
Const LAMA_TimeOut%=104
;PROGRAMMSTATUS
Const LAMA_ServerNow%=201
Const LAMA_ClientNow%=202
Const LAMA_Banned%=203
Const LAMA_Kicked%=204
Const LAMA_NameExists%=205
Const LAMA_StillBanned%=206
Const LAMA_WrongPassword%=207
;SERVER
Const LAMA_ServerChangedInformation%=301
Const LAMA_ServerDropped%=302
Const LAMA_ServerFull%=303
Const LAMA_ServerLeft%=304
Const LAMA_ServerRenamed%=305
Const LAMA_ServerStillLocked%=306
;SPIELER
Const LAMA_PlayerJoined%=401
Const LAMA_PlayerBanned%=402
Const LAMA_PlayerBlocked%=403
Const LAMA_PlayerCanceledTransfer%=404
Const LAMA_PlayerKicked%=405
Const LAMA_PlayerLeft%=406
Const LAMA_PlayerRenamed%=407
Const LAMA_PlayerTimeOut%=408
Const LAMA_PlayerDenied%=409
;BERTRAGUNG
Const LAMA_TransferCanceled%=501
Const LAMA_ReceivedBank%=502
Const LAMA_ReceivedFile%=503
Const LAMA_TransferFailed%=504
Const LAMA_TransmittedFile%=505
;AKTION
Const LAMA_CountRequest%=601
Const LAMA_JoinDenied%=602
Const LAMA_JoinRequest%=603
Const LAMA_JoinTimeOut%=604

;LAMA_GLOBALEN
;---------------------------
Global LAMA_P.LAMA_Player
Global LAMA_K.LAMA_Kicks
Global LAMA_E.LAMA_IE
Global LAMA_B.LAMA_BC
;LISTS
Global LAMA_DSL.LAMA_DSList;dynamic-serverlist
Global LAMA_SI.LAMA_SInfo;serverinfos
Global LAMA_SL.LAMA_SList;serverlist
Global LAMA_BL.LAMA_BList;banlist
;NACHRICHTEN
Global LAMA_RS.LAMA_RSec
Global LAMA_RM.LAMA_RMsg
Global LAMA_MM.LAMA_MSend
Global LAMA_NM.LAMA_NSend
;DATEIBERTRAGUNG
Global LAMA_F.LAMA_FTr
Global LAMA_FF.LAMA_FTr

;ALLGEMEIN
Const LAMA_MaxCharacters=20
Const LAMA_S_Tr%=10
Const LAMA_F_Tr%=20
Global LAMA_EmptyHash$=MD5("")
Global LAMA_BanListPath$=""
;SERVER
Global LAMA_HostID%
Global LAMA_Stream%
Global LAMA_SIP%
Global LAMA_Port%=8000
;AKTUELLER-SERVER
Global LAMA_ServerMaxPlayers%
Global LAMA_ServerPlayers%
Global LAMA_ServerName$
Global LAMA_ServerPassword%
Global LAMA_ServerLocked%
Global LAMA_SInfo%=CreateBank(0)
Global LAMA_Password$
;PROGRAMM-ATTRIBUTE
Global LAMA_Mode%
Global LAMA_MasterID%
Global LAMA_Connection%
Global LAMA_Hash$=MD5("LamaNet-V2")
Global LAMA_Code$=MD5(MilliSecs())
;PING-FUNKTION
Global LAMA_SPing%
Global LAMA_PingMS%
Global LAMA_PingOK%
Global LAMA_TPing%
Global LAMA_TPingC%
Global LAMA_PingIV%=20
Global LAMA_TOut%=5000
;NACHRICHTEN
Global LAMA_MsgID%
Global LAMA_From%
Global LAMA_Sent%
Global LAMA_P_ID%
Global LAMA_M_ID%
Global LAMA_S_ID%
Global LAMA_Secure%
Global LAMA_SecInterV%=1000
;DATEIBERTRAGUNG
Global LAMA_T_ID%
Global LAMA_FileInterV%=1000
Global LAMA_PackageS%=512
Global LAMA_CountTransfers%
Global LAMA_CountTransfersO%
Global LAMA_SavingPath$=""
Global LAMA_TempDirection
;DIM-COUNTS
Dim LAMA_TransferPath$(0)
Dim LAMA_TransferProgress#(0)
Dim LAMA_TransferMode%(0)
Dim LAMA_TransferSize%(0)
Dim LAMA_TransferT_ID%(0)
;EREIGNISSE
Global LAMA_EventID%
Global LAMA_EventGadgetID%
Global LAMA_EventPlayerID%
Global LAMA_EventInfo$
;BROADCAST
Global LAMA_BroadCastIPs%
Global LAMA_Casting%
Global LAMA_BroadCast%
Global LAMA_CastDims%
Global LAMA_LocalMS%
;BROADCAST-DIM
Dim LAMA_IP%(0)
Dim LAMA_DotIP$(0)
;SERVERLIST
Global LAMA_Dynamic%
Global LAMA_Count%
Global LAMA_Requests%
Global LAMA_CountServers%
;DIM-ALLGEMEIN
;SPEICHERBANKEN
Global LAMA_PH=CreateBank(0)
Global LAMA_SList=CreateBank(0)



;TYPE-FELDER
Type LAMA_Player
	
	Field ID%,IP%,Port%
	Field On%
	Field Ping%,TPing%,TPingC%,MSecs%,PingOK%
	Field Name$
	Field Kicks%
	
End Type
Type LAMA_Kicks
	
	Field IP%,Kicks%
	
End Type
Type LAMA_IE
	
	Field ID%
	Field PlayerID%
	Field Info$
	
End Type
Type LAMA_BC
	
	Field IP%
	
End Type
;SERVERINFO
Type LAMA_SInfo
	
	Field Info$
	
End Type
;SERVERLIST
Type LAMA_SList
	
	Field IP%,Port%
	Field Code$,Ping%
	Field Name$
	Field MaxPlayers%,Players%
	Field Password%,Locked%,BannedFrom%,BanTime$
	Field SInfo%
	
End Type
Type LAMA_DSList
	
	Field IP%,Port%
	Field MS%,Tr%
	
End Type
;BANLIST
Type LAMA_BList
	
	Field IP%,MS%
	
End Type
;NACHRICHTEN
Type LAMA_MSend
	
	Field F_ID%,M_ID%
	Field Cut%,Sec%
	Field V$
	
End Type
Type LAMA_NSend
	
	Field F_ID%,P_ID%,M_ID%
	Field S_ID%,MS%,Tr%
	Field Cut%,Sec%
	Field V$
	
End Type
Type LAMA_RMsg
	
	Field F_ID%,M_ID%
	Field V$
	
End Type
Type LAMA_RSec
	
	Field P_ID%
	Field S_ID%,MS%
	
End Type
;DATEIBERTRAGUNG
Type LAMA_FTr
	
	Field P_ID%
	Field Stream%,Path$
	Field Mode%,Cut%
	Field T_ID%,MS%,Tr%
	Field Pos%,Prg#,Byt%
	
End Type



;FUNKTIONEN
Function LAMA_Update()
	
	;VARIABLEN
	Local LAMA_Byte
	Local X,Y,Z,V$,Cut%,Path$
	;codes
	Local LAMA_HashT$
	Local LAMA_CodeT$
	Local LAMA_PasswordT$
	Local LAMA_NameT$
	;temporre-informationen
	Local LAMA_ServerMaxPlayersT%
	Local LAMA_ServerPlayersT%
	Local LAMA_ServerNameT$
	;player-types
	Local LAMA_NewP.LAMA_Player
	;player-attribute
	Local LAMA_PBanT%
	Local LAMA_PWrPT%
	Local LAMA_PSLoT%
	;universal-variblen
	Local uaccess1
	Local uaccess2
	Local uaccess3
	Local uaccess4
	;ZURUECKSETZEN
	LAMA_Sent=False
	;broadcast-berechnen
	If LAMA_BroadCast=False Then LAMA_UpdateBroadCast()
	;empfang-vorbereiten
	If LAMA_Connection Then
		LAMA_IPing();ping-funktion
		;empfangsschleife
		While RecvUDPMsg(LAMA_Stream)
			LAMA_Byte=ReadByte(LAMA_Stream)
			Select LAMA_Byte
				Case 1;server-information
					uaccess2=ReadByte(LAMA_Stream)
					LAMA_HashT=ReadString(LAMA_Stream)
					LAMA_CodeT=ReadString(LAMA_Stream)
					If LAMA_HashT=LAMA_Hash Then
						LAMA_AddEvent(LAMA_CountRequest)
						WriteByte LAMA_Stream,2
						WriteString	LAMA_Stream,LAMA_Hash
						WriteString	LAMA_Stream,LAMA_Code
						WriteShort LAMA_Stream,LAMA_ServerMaxPlayers
						WriteShort LAMA_Stream,LAMA_ServerPlayers
						WriteString LAMA_Stream,LAMA_ServerName
						
						If LAMA_Ask_IPBanned(UDPMsgIP(LAMA_Stream)) Then WriteByte LAMA_Stream,1 Else WriteByte LAMA_Stream,0
						If LAMA_ServerLocked() Then WriteByte LAMA_Stream,1 Else WriteByte LAMA_Stream,0
						If LAMA_Password=LAMA_EmptyHash Then WriteByte LAMA_Stream,0 Else WriteByte LAMA_Stream,1
						
						For uaccess1=1 To (BankSize(LAMA_SInfo))/4
							LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,(uaccess1*4)-4))
							If LAMA_SI.LAMA_SInfo<>Null Then
								WriteByte LAMA_Stream,LAMA_Ident(LAMA_SI\Info)
								WriteByte LAMA_Stream,uaccess1
								LAMA_WriteIdent(LAMA_Stream,LAMA_SI\Info)
							EndIf
						Next
						WriteByte LAMA_Stream,255
						SendUDPMsg LAMA_Stream,UDPMsgIP(LAMA_Stream),UDPMsgPort(LAMA_Stream)
						
						If uaccess2 Then
							LAMA_DSL.LAMA_DSList=LAMA_ISelectDSL(UDPMsgIP(LAMA_Stream),UDPMsgPort(LAMA_Stream))
						EndIf
					EndIf
				Case 3;spieler-beitritt
					uaccess1=ReadByte(LAMA_Stream)
					LAMA_HashT=ReadString(LAMA_Stream)
					LAMA_CodeT=ReadString(LAMA_Stream)
					LAMA_PasswordT$=ReadString(LAMA_Stream)
					LAMA_NameT$=ReadString(LAMA_Stream)
					uaccess2=LAMA_Ask_PlayerSpace()
					uaccess3=LAMA_Ask_IPBanned(UDPMsgIP(LAMA_Stream))
					If LAMA_HashT=LAMA_Hash Then
						If LAMA_PasswordT=LAMA_Password And LAMA_ServerLocked()=False And uaccess3=False And uaccess2>0 And LAMA_ServerPlayers<LAMA_ServerMaxPlayers Then
							;spielerbeitritt
							LAMA_AddEvent(LAMA_PlayerJoined%,uaccess2)
							;spieler-erstellen
							LAMA_NewP.LAMA_Player=LAMA_ISelectPlayer(uaccess2)
							LAMA_NewP\IP=UDPMsgIP(LAMA_Stream)
							LAMA_NewP\Port=UDPMsgPort(LAMA_Stream)
							LAMA_K.LAMA_Kicks=LAMA_ISelectKicks(LAMA_NewP\IP)
							LAMA_NewP\Kicks=LAMA_K\Kicks
							LAMA_NewP\On=True
							LAMA_NewP\Name=LAMA_NameT
							;server-werte-ndern
							LAMA_ServerPlayers=LAMA_ServerPlayers+1
							;antwort-senden
							WriteByte LAMA_Stream,4
							;via-ip
							If uaccess1 Then
								WriteString LAMA_Stream,LAMA_ServerName
								WriteShort LAMA_Stream,LAMA_ServerMaxPlayers
								WriteShort LAMA_Stream,LAMA_ServerPlayers
								;server-informationen
								For uaccess1=1 To (BankSize(LAMA_SInfo))/4
									LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,(uaccess1*4)-4))
									If LAMA_SI.LAMA_SInfo<>Null Then
										WriteByte LAMA_Stream,LAMA_Ident(LAMA_SI\Info)
										WriteByte LAMA_Stream,uaccess1
										LAMA_WriteIdent(LAMA_Stream,LAMA_SI\Info)
									EndIf
								Next
								WriteByte LAMA_Stream,255
							EndIf
							WriteShort LAMA_Stream,LAMA_MasterID
							WriteShort LAMA_Stream,LAMA_NewP\ID
							WriteShort LAMA_Stream,LAMA_NewP\Kicks;kick-anzahl
							WriteString LAMA_Stream,LAMA_NewP\Name
							;spieler-informationen
							For LAMA_P.LAMA_Player=Each LAMA_Player
								If LAMA_P\ID<>LAMA_NewP\ID And LAMA_P\On=True Then
									WriteByte LAMA_Stream,1
									WriteShort LAMA_Stream,LAMA_P\ID
									WriteShort LAMA_Stream,LAMA_P\Kicks;kick-anzahl
									WriteString LAMA_Stream,LAMA_P\Name
								EndIf
							Next
							WriteByte LAMA_Stream,0
							SendUDPMsg LAMA_Stream,LAMA_NewP\IP,LAMA_NewP\Port
							;spieler-information-an-alle-anderen
							For LAMA_P.LAMA_Player=Each LAMA_Player
								If LAMA_P\ID<>LAMA_NewP\ID And LAMA_P\ID<>LAMA_MasterID And LAMA_P\On=True Then
									WriteByte LAMA_Stream,7
									WriteShort LAMA_Stream,LAMA_NewP\ID
									WriteShort LAMA_Stream,LAMA_NewP\Kicks;kick-anzahl
									WriteString LAMA_Stream,LAMA_NewP\Name
									SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
								EndIf
							Next
						Else
							;variablen-bearbeiten
							If uaccess2>1 Then uaccess2=1
							uaccess2=1-uaccess2
							;antwort-senden
							WriteByte LAMA_Stream,5
							WriteByte LAMA_Stream,uaccess2
							WriteByte LAMA_Stream,uaccess3
							WriteByte LAMA_Stream,LAMA_ServerLocked
							If LAMA_PasswordT<>LAMA_Password Then WriteByte LAMA_Stream,1 Else WriteByte LAMA_Stream,0
							SendUDPMsg LAMA_Stream,UDPMsgIP(LAMA_Stream),UDPMsgPort(LAMA_Stream)
							;spielerablehnung
							LAMA_AddEvent(LAMA_PlayerDenied%)
						EndIf
					EndIf
				Case 7;spieler-tritt-bei
					;spieler-erstellen
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(ReadShort(LAMA_Stream))
					LAMA_P\Kicks=ReadShort(LAMA_Stream)
					LAMA_P\Name=ReadString(LAMA_Stream)
					LAMA_P\On=True
					;server-werte-ndern
					LAMA_ServerPlayers=LAMA_ServerPlayers+1
					;event-erstellen
					LAMA_AddEvent(LAMA_PlayerJoined,LAMA_P\ID)
				Case 8;ping-funktion(empf.client)
					WriteByte LAMA_Stream,9
					WriteShort LAMA_Stream,LAMA_MasterID
					SendUDPMsg LAMA_Stream,LAMA_SIP,LAMA_Port
				Case 9;ping-funktion(empf.server)
					uaccess1=ReadShort(LAMA_Stream)
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
					If LAMA_P\On=True Then
						LAMA_P\TPing=LAMA_P\TPing+(MilliSecs()-LAMA_P\MSecs)
						LAMA_P\TPingC=LAMA_P\TPingC+1
						LAMA_P\PingOK=False
					EndIf
				Case 10;ping-information(empf.client)
					While ReadByte(LAMA_Stream)=True
						uaccess1=ReadShort(LAMA_Stream)
						uaccess2=ReadShort(LAMA_Stream)
						LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
						If LAMA_P\On=True Then
							LAMA_P\Ping=uaccess2
							If uaccess1<>LAMA_MasterID Then LAMA_P\Ping=LAMA_P\Ping+LAMA_SPing
						EndIf
					Wend
				Case 11;ping-funktion(empf.server)
					WriteByte LAMA_Stream,12
					SendUDPMsg LAMA_Stream,UDPMsgIP(LAMA_Stream),UDPMsgPort(LAMA_Stream)
				Case 12;ping-funktion(empf.client)
					LAMA_TPing=LAMA_TPing+(MilliSecs()-LAMA_PingMS)
					LAMA_TPingC=LAMA_TPingC+1
					LAMA_PingOK=False
				Case 13;nachricht-empfangen/weiterleiten
					LAMA_IRecv()
				Case 14;sicher-antwort
					uaccess1=ReadShort(LAMA_Stream);von
					uaccess2=ReadShort(LAMA_Stream);an
					uaccess3=ReadShort(LAMA_Stream);sicherid
					If uaccess2=LAMA_MasterID Then
						For LAMA_NM.LAMA_NSend=Each LAMA_NSend
							If LAMA_NM\S_ID=uaccess3 And LAMA_NM\P_ID=uaccess1 Then
								;DebugLog "erhalte antwort -lsche... mit ID - "+LAMA_NM\S_ID
								Delete LAMA_NM.LAMA_NSend
							EndIf
						Next
					Else
						If LAMA_Online(uaccess2) Then
							WriteByte LAMA_Stream,14
							WriteShort LAMA_Stream,uaccess1
							WriteShort LAMA_Stream,uaccess2
							WriteShort LAMA_Stream,uaccess3
							SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
						EndIf
					EndIf
				Case 15;timeout
					uaccess1=ReadShort(LAMA_Stream);spielerid
					LAMA_AddEvent(LAMA_PlayerLeft,uaccess1)
					LAMA_IFreePlayer(uaccess1)
				Case 16;spieler-verlsst-spiel(empf.server)
					uaccess1=ReadShort(LAMA_Stream);spielerid
					For LAMA_P.LAMA_Player=Each LAMA_Player
						If LAMA_P\ID<>LAMA_MasterID And LAMA_P\On=True Then
							WriteByte LAMA_Stream,17
							WriteShort LAMA_Stream,uaccess1
							SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
						EndIf
					Next
					LAMA_AddEvent(LAMA_PlayerLeft,uaccess1)
					LAMA_IFreePlayer(uaccess1)
				Case 17;spieler-verlsst-spiel(client)
					uaccess1=ReadShort(LAMA_Stream);spielerid
					If uaccess1<>LAMA_HostID Then
						LAMA_AddEvent(LAMA_PlayerLeft,uaccess1)
						LAMA_IFreePlayer(uaccess1)
					Else
						LAMA_AddEvent(LAMA_ServerLeft,uaccess1)
						LAMA_IFreeAllPlayers()
						LAMA_Connection=False
					EndIf
				Case 18;datei-empfangen
					LAMA_IRFile()
				Case 19;datei-transfer-antwort(empf.dateiversender)
					LAMA_IAFile()
				Case 20;spieler-benennt-sich-um
					uaccess1=ReadShort(LAMA_Stream)
					LAMA_NameT=ReadString(LAMA_Stream)
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
					If LAMA_P\On=True Then
						LAMA_AddEvent(LAMA_PlayerRenamed,LAMA_P\ID,LAMA_P\Name)
						LAMA_P\Name=LAMA_NameT
					EndIf
				Case 21;rename-weiterleiten
					uaccess1=ReadShort(LAMA_Stream)
					LAMA_NameT=ReadString(LAMA_Stream)
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
					If LAMA_P\On=True Then
						LAMA_AddEvent(LAMA_PlayerRenamed,LAMA_P\ID,LAMA_P\Name)
						LAMA_P\Name=LAMA_NameT
						For LAMA_P.LAMA_Player=Each LAMA_Player
							If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID And LAMA_P\ID<>uaccess1 Then
								;absenden
								WriteByte LAMA_Stream,20
								WriteShort LAMA_Stream,uaccess1
								WriteString LAMA_Stream,LAMA_NameT
								LAMA_ISendUDPMsg(LAMA_Host)
							EndIf
						Next
					EndIf
				Case 22;spieler-wurde-gekickt
					uaccess1=ReadShort(LAMA_Stream)
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
					If LAMA_P\On=True Then
						LAMA_P\On=False
						If uaccess1=LAMA_MasterID Then
							LAMA_AddEvent(LAMA_Kicked,LAMA_P\ID)
						Else
							LAMA_AddEvent(LAMA_PlayerKicked,LAMA_P\ID)
						EndIf
					EndIf
					If uaccess1=LAMA_MasterID Then
						LAMA_Connection=False
					EndIf
				Case 23;server-wurde-umbenannt
					LAMA_AddEvent(LAMA_ServerRenamed,LAMA_HostID,LAMA_ServerName)
					LAMA_ServerName=ReadString(LAMA_Stream)
				Case 24;spieler-wurde-gebannt
					uaccess1=ReadShort(LAMA_Stream);spieler-um-den-es-sich-handelt
					V=ReadString(LAMA_Stream);banngrund
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
					If LAMA_P\On=True Then
						LAMA_P\On=False
						If uaccess1=LAMA_MasterID Then
							LAMA_AddEvent(LAMA_Banned,LAMA_P\ID,V)
						Else
							LAMA_AddEvent(LAMA_PlayerBanned,LAMA_P\ID)
						EndIf
					EndIf
					If uaccess1=LAMA_MasterID Then
						LAMA_Connection=False
					EndIf
				Case 25;ordner-empfangen
					uaccess1=ReadShort(LAMA_Stream);von
					uaccess2=ReadShort(LAMA_Stream);an
					If uaccess2=LAMA_MasterID Then;transfer-beginnen
						V=LAMA_IRenameFolder(LAMA_SavingPath+ReadString(LAMA_Stream))
						CreateDir(V)
						While ReadByte(LAMA_Stream)=True;aktiv
							uaccess3=ReadShort(LAMA_Stream);transferid
							uaccess4=ReadInt(LAMA_Stream);gesamt-bytes
							Path=ReadString(LAMA_Stream);dateiname(+pfad)
							LAMA_ICreateMultiDir(V+Path)
							;type-eintrag-erstellen
							LAMA_F.LAMA_FTr=New LAMA_FTr
							LAMA_F\Stream=WriteFile(V+Path)
							LAMA_F\Mode=LAMA_FRecv
							LAMA_F\P_ID=uaccess1
							LAMA_F\T_ID=uaccess3
							LAMA_F\Byt=uaccess4
							LAMA_F\Path=V+Path
							LAMA_F\Pos=-1
							;LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
						Wend
					Else;weiterleiten
						LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess2)
						If LAMA_P\On=True Then
							WriteByte LAMA_Stream,25;kennung
							WriteShort LAMA_Stream,uaccess1;von
							WriteShort LAMA_Stream,uaccess2;an
							WriteString LAMA_Stream,ReadString(LAMA_Stream)
							While ReadByte(LAMA_Stream)
								WriteByte LAMA_Stream,True;aktiv
								WriteShort LAMA_Stream,ReadShort(LAMA_Stream);transferid
								WriteInt LAMA_Stream,ReadInt(LAMA_Stream);gesamt-bytes
								WriteString LAMA_Stream,ReadString(LAMA_Stream);dateiname
							Wend
							WriteByte LAMA_Stream,False;inaktiv
						Else
							LAMA_IClearStream(LAMA_Stream)
						EndIf
					EndIf
				Case 26;dynamisch-leeren
					LAMA_IClearStream(LAMA_Stream)
				Case 27;dynamische-serverlist-antwort(empf.server)
					For LAMA_DSL.LAMA_DSList=Each LAMA_DSList
						If LAMA_DSL\IP=UDPMsgIP(LAMA_Stream) And LAMA_DSL\Port=UDPMsgPort(LAMA_Stream) Then LAMA_DSL\Tr=0
					Next
			End Select
			LAMA_IClearStream(LAMA_Stream)
		Wend
		LAMA_ISend();sende-funktion
		LAMA_ITFile();datei-funktion
		LAMA_IUpdateExists();sichere-empfangsfunktion(lscht-bereits-empfangene-nicht-aktualisierte-antworten... fr outsider vll nicht ganz verstndlich xD)
		LAMA_IDynamicSList();dynamische-serverlist
		LAMA_ICountAll();zhlt-alle-type-eintrge-und-speichert-anzahlen-in-variablen
	Else
		If LAMA_Count=True And LAMA_BroadCast=True Then;wenn-serverlist-erstellt-wird
			For X=1 To LAMA_Requests;suchanfrage-senden
				For LAMA_B.LAMA_BC=Each LAMA_BC
					WriteByte LAMA_Stream,1
					WriteByte LAMA_Stream,LAMA_Dynamic
					WriteString	LAMA_Stream,LAMA_Hash
					WriteString	LAMA_Stream,LAMA_Code
					SendUDPMsg LAMA_Stream,LAMA_B\IP,LAMA_Port
				Next
				LAMA_Requests=0
			Next
			While RecvUDPMsg(LAMA_Stream);serverinformationen-empfangen
				LAMA_Byte=ReadByte(LAMA_Stream)
				Select LAMA_Byte
					Case 2;antwort
						LAMA_HashT=ReadString(LAMA_Stream)
						LAMA_CodeT=ReadString(LAMA_Stream)
						LAMA_ServerMaxPlayersT=ReadShort(LAMA_Stream)
						LAMA_ServerPlayersT=ReadShort(LAMA_Stream)
						LAMA_ServerNameT=ReadString(LAMA_Stream)
						uaccess1=ReadByte(LAMA_Stream);banned
						uaccess2=ReadByte(LAMA_Stream);locked
						uaccess3=ReadByte(LAMA_Stream);password
						If LAMA_HashT=LAMA_Hash Then
							uaccess1=False;existenz-prfen
							For LAMA_SL.LAMA_SList=Each LAMA_SList
								If LAMA_SL\Code=LAMA_CodeT Then uaccess1=True:Exit
							Next
							If uaccess1=False Then
								LAMA_SL.LAMA_SList=New LAMA_SList
								LAMA_SL\Code=LAMA_CodeT
								LAMA_SL\IP=UDPMsgIP(LAMA_Stream)
								LAMA_SL\Port=UDPMsgPort(LAMA_Stream)
								LAMA_SL\MaxPlayers=LAMA_ServerMaxPlayersT
								LAMA_SL\Players=LAMA_ServerPlayersT
								LAMA_SL\Name=LAMA_ServerNameT
								LAMA_SL\BannedFrom=uaccess1;banned
								LAMA_SL\Locked=uaccess2;locked
								LAMA_SL\Password=uaccess3;password
								LAMA_SL\SInfo=CreateBank(0)
								Repeat
									uaccess2=ReadByte(LAMA_Stream)
									If uaccess2=255 Then Exit
									uaccess3=ReadByte(LAMA_Stream)
									If uaccess3*4>BankSize(LAMA_SL\SInfo) Then ResizeBank LAMA_SL\SInfo,uaccess3*4
									LAMA_SI.LAMA_SInfo=New LAMA_SInfo
									LAMA_SI\Info=LAMA_ReadIdent(LAMA_Stream,uaccess2)
									PokeInt LAMA_SL\SInfo,uaccess3*4-4,Handle(LAMA_SI.LAMA_SInfo)
								Forever
								;handlewert-speichern
								ResizeBank(LAMA_SList,BankSize(LAMA_SList)+4)
								PokeInt(LAMA_SList,BankSize(LAMA_SList)-4,Handle(LAMA_SL.LAMA_SList))
								LAMA_CountServers=LAMA_CountServers+1
							Else;rest-auslesen
								LAMA_IClearStream(LAMA_Stream)
							EndIf
						Else;rest-auslesen
							LAMA_IClearStream(LAMA_Stream)
						EndIf
					Case 26;dynamisch
						For LAMA_SL.LAMA_SList=Each LAMA_SList
							If LAMA_SL\IP=UDPMsgIP(LAMA_Stream) Then
								LAMA_SL\Name=ReadString(LAMA_Stream)
								LAMA_SL\MaxPlayers=ReadShort(LAMA_Stream)
								LAMA_SL\Players=ReadShort(LAMA_Stream)
								LAMA_SL\Password=ReadByte(LAMA_Stream)
								LAMA_SL\Locked=ReadByte(LAMA_Stream)
								LAMA_SL\BannedFrom=ReadByte(LAMA_Stream)
								LAMA_SL\BanTime=ReadString(LAMA_Stream)
								Repeat;server-informationen
									uaccess2=ReadByte(LAMA_Stream)
									If uaccess2=255 Then Exit
									uaccess3=ReadByte(LAMA_Stream)
									If uaccess3*4>BankSize(LAMA_SL\SInfo) Then ResizeBank(LAMA_SL\SInfo,uaccess3*4)
									LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SL\SInfo,uaccess3*4-4))
									If LAMA_SI.LAMA_SInfo<>Null Then
										LAMA_SI\Info=LAMA_ReadIdent(LAMA_Stream,uaccess2)
									Else
										LAMA_SI.LAMA_SInfo=New LAMA_SInfo
										LAMA_SI\Info=LAMA_ReadIdent(LAMA_Stream,uaccess2)
										PokeInt LAMA_SL\SInfo,uaccess3*4-4,Handle(LAMA_SI.LAMA_SInfo)
									EndIf
								Forever
								
								For LAMA_B.LAMA_BC=Each LAMA_BC
									WriteByte LAMA_Stream,27
									SendUDPMsg LAMA_Stream,LAMA_B\IP,LAMA_Port
								Next
							EndIf
						Next
						LAMA_IClearStream(LAMA_Stream)
				End Select
			Wend
		EndIf
	EndIf
	
	
	
End Function
;NACHRICHTEN-SENDEN/EMPFANGEN
Function LAMA_NewBlock()
	
	If Last LAMA_MSend<>Null Then
		LAMA_MM.LAMA_MSend=Last LAMA_MSend
		If LAMA_MM\Cut<2 Then LAMA_MM\Cut=LAMA_MM\Cut+2
	EndIf
	If Last LAMA_NSend<>Null Then
		LAMA_NM.LAMA_NSend=Last LAMA_NSend
		If LAMA_NM\Cut<2 Then LAMA_NM\Cut=LAMA_NM\Cut+2
	EndIf
	LAMA_Sent=False
	
End Function
Function LAMA_Send(PlayerID,MsgID,Value$,Secure=0)
	
	;variablen-vorbereiten
	If Secure<0 Then Secure=0
	If Secure>1 Then Secure=1
	Local Cut%
	If PlayerID<>LAMA_MasterID Then
		;vorherige-blcke-bearbeiten
		If LAMA_Sent=False Or LAMA_P_ID<>PlayerID Or LAMA_M_ID<>MsgID Or LAMA_Secure<>Secure Then
			Cut=1
		Else
			Cut=0
		EndIf
		If PlayerID=0 Then
			If LAMA_Mode=1 Or (LAMA_Mode=2 And Secure=1) Then
				LAMA_MM.LAMA_MSend=New LAMA_MSend
				LAMA_MM\F_ID=LAMA_MasterID
				LAMA_MM\M_ID=MsgID
				LAMA_MM\Sec=Secure
				LAMA_MM\V=Value
				LAMA_MM\Cut=Cut
			ElseIf LAMA_Mode=2 And Secure=0 Then
				LAMA_NM.LAMA_NSend=New LAMA_NSend
				LAMA_NM\P_ID=PlayerID
				LAMA_NM\F_ID=LAMA_MasterID
				LAMA_NM\M_ID=MsgID
				LAMA_NM\Sec=Secure
				LAMA_NM\V=Value
				LAMA_NM\Cut=Cut
			EndIf
		Else
			If LAMA_Online(PlayerID) Then
				LAMA_NM.LAMA_NSend=New LAMA_NSend
				LAMA_NM\P_ID=PlayerID
				LAMA_NM\F_ID=LAMA_MasterID
				LAMA_NM\M_ID=MsgID
				LAMA_NM\Sec=Secure
				LAMA_NM\V=Value
				LAMA_NM\Cut=Cut
			EndIf
		EndIf
	EndIf
	
	LAMA_Sent=True
	LAMA_P_ID=PlayerID
	LAMA_M_ID=MsgID
	LAMA_Secure=Secure
	
	
End Function
Function LAMA_Recv()
	
	If First LAMA_RMsg<>Null Then
		;variablen-vorbereiten
		LAMA_RM.LAMA_RMsg=First LAMA_RMsg
		;werte-bergeben
		LAMA_MsgID%=LAMA_RM\M_ID
		LAMA_From%=LAMA_RM\F_ID
		Return 1
	Else
		LAMA_MsgID%=0
		LAMA_From%=0
		Return 0
	EndIf
	
End Function
Function LAMA_Read$()
	
	;variablen-vorbereiten
	If First LAMA_RMsg<>Null Then
		LAMA_RM.LAMA_RMsg=First LAMA_RMsg
		
		LAMA_From%=LAMA_RM\F_ID
		LAMA_MsgID%=LAMA_RM\M_ID
		Local LAMA_Value$=LAMA_RM\V
		Delete LAMA_RM.LAMA_RMsg
		;rueckgabe-wert
		Return LAMA_Value$
	EndIf
	
End Function
;DATEIBERTRAGUNG
Function LAMA_SendFile(PlayerID%,Path$)
	
	If FileType(Path$)=1 And PlayerID<>LAMA_MasterID Then
		If PlayerID=0 Then
			For LAMA_P.LAMA_Player=Each LAMA_Player
				If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID Then
					LAMA_SendFile(LAMA_P\ID,Path)
				EndIf
			Next
		Else
			If LAMA_Online(PlayerID) Then
				LAMA_F.LAMA_FTr=New LAMA_FTr
				LAMA_F\Stream=ReadFile(Path)
				LAMA_F\Path=LAMA_IFileName(Path)
				LAMA_F\Mode=LAMA_FSend
				LAMA_F\P_ID=PlayerID
				LAMA_F\Byt=FileSize(Path$)
				LAMA_T_ID=(LAMA_T_ID+1) Mod 65535
				LAMA_F\T_ID=LAMA_T_ID+1
			EndIf
		EndIf
	EndIf
	
End Function
Function LAMA_SendFolder(PlayerID%,FolderPath$)
	
	If FileType(FolderPath)=2 And PlayerID<>LAMA_MasterID Then
		If PlayerID=0 Then
			For LAMA_P.LAMA_Player=Each LAMA_Player
				If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID Then
					LAMA_SendFolder(LAMA_P\ID,FolderPath)
				EndIf
			Next
		Else
			;If LAMA_Online(PlayerID) Then
				LAMA_ISendDir(PlayerID,FolderPath)
				WriteByte LAMA_Stream,False;inaktiv
				;senden
				LAMA_ISendUDPMsg()
			;EndIf
		EndIf
	EndIf
	
End Function
Function LAMA_CancelTransfer(TransferID%)
	
	LAMA_F.LAMA_FTr=Object.LAMA_FTr(LAMA_TransferT_ID(TransferID))
	If LAMA_F.LAMA_FTr<>Null Then
		WriteByte LAMA_Stream,19;kennung
		WriteByte LAMA_Stream,3;bertragung-abbrechen
		WriteShort LAMA_Stream,LAMA_MasterID;von
		WriteShort LAMA_Stream,LAMA_F\P_ID;an
		WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
		;senden
		LAMA_ISendUDPMsg()
		If LAMA_F\Stream>0 Then CloseFile LAMA_F\Stream:LAMA_F\Stream=0
		If LAMA_F\Mode=LAMA_FRecv Then DeleteFile LAMA_F\Path
		LAMA_AddEvent(LAMA_TransferCanceled,LAMA_F\P_ID,LAMA_F\Path)
		Delete LAMA_F.LAMA_FTr
		Return 1
	EndIf
	Return 0
	
End Function
Function LAMA_SetPackageSize(Size%=512)
	If Size<1 Then Size=1
	LAMA_PackageS=Size
End Function

;ERSTELLEN-SPIELBEITRITT
Function LAMA_HostServer(ServerName$,MaxPlayers,Name$,ServerPassword$="")
	
	;variablen-vorbereiten
	Local uaccess1
	;variablen-vorbereiten
	If MaxPlayers<2 Then MaxPlayers=2
	Name$=Left(Name$,LAMA_MaxCharacters)
	;anfang
	If LAMA_Stream>0 Then CloseUDPStream(LAMA_Stream)
	LAMA_Stream=CreateUDPStream(LAMA_Port)
	If LAMA_Stream>0 Then
		;serverattribute
		LAMA_ServerPlayers=1
		LAMA_MasterID=1
		LAMA_HostID=1
		LAMA_Mode=LAMA_Host
		LAMA_ServerMaxPlayers=MaxPlayers
		LAMA_ServerName=ServerName
		LAMA_Password=MD5(ServerPassword$)
		;bank-einstellen
		ResizeBank(LAMA_PH,MaxPlayers*4)
		;spieler-erstellen
		LAMA_ICreateAllPlayers(MaxPlayers)
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(1)
		LAMA_P\Name=Name
		LAMA_P\On=True
		;verbindung-herstellen
		LAMA_Connection=True
		;events-erstellen
		LAMA_AddEvent(LAMA_Connected,1)
		LAMA_AddEvent(LAMA_Hosted,1)
		Return 1	
	Else
		LAMA_Stream=0
		Return 0
	EndIf
	
End Function
Function LAMA_JoinServer(Server$,Name$,Password$="",MaxPing%=1000)
	
	;variablen-vorbereiten
	Name$=Left(Name$,LAMA_MaxCharacters)
	Local LAMA_Byte%
	Local ViaIP%
	Local Msecs%
	Local Info$
	;uinversal-werte
	Local uaccess1
	Local uaccess2
	Local uaccess3
	Local uaccess4
	;via-ip-bestimmen
	If LAMA_Ident(Server$)=5 Then ViaIP=1
	;udp-einstellen
	If LAMA_Stream=0 Then LAMA_Stream=CreateUDPStream()
	If LAMA_Stream>0 Then
		
		WriteByte LAMA_Stream,3
		WriteByte LAMA_Stream,ViaIP
		WriteString	LAMA_Stream,LAMA_Hash
		WriteString	LAMA_Stream,LAMA_Code
		WriteString LAMA_Stream,MD5(Password)
		WriteString LAMA_Stream,Name
		;via-ip-unterschied
		If ViaIP=True Then
			LAMA_SIP=LAMA_IIP(Server)
		EndIf
		If ViaIP=False Then
			LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(Int(Server)-1)*4))
			LAMA_ServerName=LAMA_SL\Name
			LAMA_ServerMaxPlayers=LAMA_SL\MaxPlayers
			LAMA_ServerPlayers=LAMA_SL\Players
			LAMA_SIP=LAMA_SL\IP
			;server-informationen-bergeben
			ResizeBank(LAMA_SInfo,BankSize(LAMA_SL\SInfo))
			For uaccess1=1 To (BankSize(LAMA_SL\SInfo))/4
				LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SL\SInfo,(uaccess1*4)-4))
				If LAMA_SI.LAMA_SInfo<>Null Then
					Info=LAMA_SI\Info
					LAMA_SI.LAMA_SInfo=New LAMA_SInfo
					LAMA_SI\Info=Info
					PokeInt(LAMA_SInfo,(uaccess1*4)-4,Handle(LAMA_SI.LAMA_SInfo))
				EndIf
			Next
		EndIf
		SendUDPMsg(LAMA_Stream,LAMA_SIP,LAMA_Port)
		;millisekunden-speichern
		Msecs=MilliSecs()+MaxPing
		;warteschleife
		While Msecs>MilliSecs()
			While RecvUDPMsg(LAMA_Stream);antwort-empfangen
				LAMA_Byte=ReadByte(LAMA_Stream)
				Select LAMA_Byte
					Case 4;antwort-akzeptierung
						;via-ip-verbindung
						If ViaIP Then
							LAMA_ServerName=ReadString(LAMA_Stream)
							LAMA_ServerMaxPlayers=ReadShort(LAMA_Stream)
							LAMA_ServerPlayers=ReadShort(LAMA_Stream)
							Repeat;server-informationen
								uaccess2=ReadByte(LAMA_Stream)
								If uaccess2=255 Then Exit
								uaccess3=ReadByte(LAMA_Stream)
								If uaccess3*4>BankSize(LAMA_SInfo) Then ResizeBank(LAMA_SInfo,uaccess3*4)
								LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,uaccess3*4-4))
								If LAMA_SI.LAMA_SInfo<>Null Then
									LAMA_SI\Info=LAMA_ReadIdent(LAMA_Stream,uaccess2)
								Else
									LAMA_SI.LAMA_SInfo=New LAMA_SInfo
									LAMA_SI\Info=LAMA_ReadIdent(LAMA_Stream,uaccess2)
									PokeInt LAMA_SInfo,uaccess3*4-4,Handle(LAMA_SI.LAMA_SInfo)
								EndIf
							Forever
						Else
							LAMA_ServerPlayers=LAMA_ServerPlayers+1
						EndIf
						;server-attribute
						LAMA_HostID=ReadShort(LAMA_Stream)
						;bank-einstellen
						ResizeBank(LAMA_PH,LAMA_ServerMaxPlayers*4)
						;spieler-erstellen
						LAMA_ICreateAllPlayers(LAMA_ServerMaxPlayers)
						;spieler-bearbeiten
						LAMA_P.LAMA_Player=LAMA_ISelectPlayer(ReadShort(LAMA_Stream))
						LAMA_P\Kicks=ReadShort(LAMA_Stream)
						LAMA_P\Name=ReadString(LAMA_Stream)
						LAMA_P\On=True
						;serverattribute
						LAMA_MasterID=LAMA_P\ID
						LAMA_Mode=LAMA_Client
						;spieler-daten-auslesen
						While ReadByte(LAMA_Stream)=True
							;spieler-bearbeiten
							LAMA_P.LAMA_Player=LAMA_ISelectPlayer(ReadShort(LAMA_Stream))
							LAMA_P\Kicks=ReadShort(LAMA_Stream)
							LAMA_P\Name=ReadString(LAMA_Stream)
							LAMA_P\On=True
						Wend
						;event-erstellen
						LAMA_AddEvent(LAMA_Joined,LAMA_MasterID)
						LAMA_AddEvent(LAMA_Connected,LAMA_MasterID)
						;verbindung-herstellen
						LAMA_Connection=True
						Return 1
					Case 5;verweigerung
						uaccess1=ReadByte(LAMA_Stream)
						uaccess2=ReadByte(LAMA_Stream)
						uaccess3=ReadByte(LAMA_Stream)
						uaccess4=ReadByte(LAMA_Stream)
						If uaccess1 Then LAMA_AddEvent(LAMA_ServerFull)
						If uaccess2 Then LAMA_AddEvent(LAMA_StillBanned)
						If uaccess3 Then LAMA_AddEvent(LAMA_ServerStillLocked)
						If uaccess4 Then LAMA_AddEvent(LAMA_WrongPassword)
						LAMA_AddEvent(LAMA_JoinDenied%)
						LAMA_Connection=False
						Return 0
					Case 6;reserviert-fr-falsche-seriennummer
				End Select
			Wend
		Wend
		Return 0
	Else
		Return 0
	EndIf
	
End Function
Function LAMA_CloseServer(Drop%=0)
	
	If LAMA_Connection Then
		Select LAMA_Mode
			Case LAMA_Host
				For LAMA_P.LAMA_Player=Each LAMA_Player
					If LAMA_P\ID<>LAMA_MasterID And LAMA_P\On=True Then
						WriteByte LAMA_Stream,17
						WriteShort LAMA_Stream,LAMA_MasterID
						SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
					EndIf
				Next
				LAMA_IFreeAllPlayers()
			Case LAMA_Client
				WriteByte LAMA_Stream,16
				WriteShort LAMA_Stream,LAMA_MasterID
				SendUDPMsg LAMA_Stream,LAMA_SIP,LAMA_Port
				LAMA_IFreeAllPlayers()
		End Select
		LAMA_Connection=False
	EndIf
	
End Function
Function LAMA_SetPort(Port=8000)
	LAMA_Port=Port
End Function

;SERVERLIST-FUNKTIONEN
Function LAMA_StartCountServers(Servers%=0,Dynamic%=1)
	
	If LAMA_Stream=0 Then LAMA_Stream=CreateUDPStream()
	If LAMA_Stream>0 Then
		;such-daten-bestimmen
		LAMA_Requests=1
		LAMA_Count=True
		LAMA_Dynamic=Dynamic
		Return 1
	Else
		Return 0
	EndIf
	
	
End Function
Function LAMA_SendCountRequest(Clear%=0)
	
	If Clear Then
		For LAMA_SL.LAMA_SList=Each LAMA_SList
			FreeBank(LAMA_SL\SInfo)
			Delete LAMA_SL.LAMA_SList
		Next
		ResizeBank(LAMA_SList,0)
		LAMA_CountServers=0
	EndIf
	LAMA_Requests=LAMA_Requests+1
	
End Function
Function LAMA_StopCountServers()
	
	LAMA_Requests=0
	LAMA_Count=False
	
End Function

;SERVER-ATTRIBUTE
Function LAMA_ServerInformation$(ServerID,InfoID)
	
	If ServerID%=0 Then
		LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,(InfoID*4)-4))
		If LAMA_SI.LAMA_SInfo<>Null Then
			Return LAMA_SI\Info
		EndIf
	Else If ServerID%>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID*4)-4))
		If LAMA_SL.LAMA_SList<>Null Then
			LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SL\SInfo,(InfoID*4)-4))
			If LAMA_SI.LAMA_SInfo<>Null Then
				Return LAMA_SI\Info
			EndIf
		EndIf
	EndIf
	
End Function
Function LAMA_HostID%()
	
	Return LAMA_HostID
	
End Function

;SERVER-BEARBEITEN
Function LAMA_SetServerInformation(InfoID%,Information$="")
	
	If InfoID%*4>BankSize(LAMA_SInfo) Then ResizeBank(LAMA_SInfo,InfoID*4)
	LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,(InfoID*4)-4))
	If LAMA_SI.LAMA_SInfo<>Null Then
		LAMA_SI\Info=Information
	Else
		LAMA_SI.LAMA_SInfo=New LAMA_SInfo
		LAMA_SI\Info=Information
		PokeInt LAMA_SInfo,(InfoID*4)-4,Handle(LAMA_SI.LAMA_SInfo)
	EndIf
		
	
End Function
Function LAMA_LockServer()
	
	LAMA_ServerLocked=True
	
End Function
Function LAMA_UnLockServer()
	
	LAMA_ServerLocked=False
	
End Function
Function LAMA_SwitchLock()
	
	LAMA_ServerLocked=1-LAMA_ServerLocked
	
End Function
Function LAMA_RenameServer(ServerName$="LamaNet")
	
	If LAMA_Mode=LAMA_Host Then
		LAMA_AddEvent(LAMA_ServerRenamed,LAMA_MasterID,LAMA_ServerName)
		LAMA_ServerName=ServerName
		For LAMA_P.LAMA_Player=Each LAMA_Player
			If LAMA_P\ID<>LAMA_MasterID And LAMA_P\On=True Then
				WriteByte LAMA_Stream,23
				WriteString LAMA_Stream,LAMA_ServerName
				LAMA_ISendUDPMsg(LAMA_Host)
			EndIf
		Next
	EndIf
	
End Function

;SONSTIGES
Function LAMA_SetSerial(MyString$="LamaNet-V2")
	LAMA_Hash$=MD5(MyString$)
End Function
Function LAMA_SetOutPut(Path$="")
	
	Path=Replace(Path,"/","\")
	If Len(Path)>0 Then If RSet(Path,1)<>"\" Then Path=Path+"\"
	LAMA_SavingPath=Path
	
End Function
Function LAMA_SetBanListPath(Path$="")
	
	Path=Replace(Path,"/","\")
	If Len(Path)>0 Then If RSet(Path,1)<>"\" Then Path=Path+"\"
	LAMA_BanListPath=Path
	
End Function

;SPIELER-ATTRIBUTE
Function LAMA_Name$(PlayerID=0)
	
	If PlayerID>0 And PlayerID<=LAMA_ServerMaxPlayers Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		Return LAMA_P\Name
	EndIf
	
End Function
Function LAMA_Kicks%(PlayerID=0)
	
	If PlayerID>0 And PlayerID<=LAMA_ServerMaxPlayers Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		Return LAMA_P\Kicks
	EndIf
	
End Function
Function LAMA_Online(PlayerID=0)
	
	If PlayerID>0 And PlayerID<=LAMA_ServerMaxPlayers Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		If LAMA_P\On=True Then Return 1
	EndIf
	Return 0
	
End Function
Function LAMA_Ping(PlayerID=0)
	
	If PlayerID>0 And PlayerID<=LAMA_ServerMaxPlayers Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		Return LAMA_P\Ping
	EndIf
	
End Function

;SPIELER-BEARBEITEN
Function LAMA_RenamePlayer(PlayerID%,Name$)
	
	If LAMA_Connection Then
		Select LAMA_Mode
			Case LAMA_Host
				LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
				If LAMA_P\On=True Then
					LAMA_AddEvent(LAMA_PlayerRenamed,LAMA_P\ID,LAMA_P\Name)
					LAMA_P\Name=Name
					For LAMA_P.LAMA_Player=Each LAMA_Player
						If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID Then
							;absenden
							WriteByte LAMA_Stream,20
							WriteShort LAMA_Stream,PlayerID
							WriteString LAMA_Stream,Name
							LAMA_ISendUDPMsg(LAMA_Host)
						EndIf
					Next
				EndIf
			Case LAMA_Client
				If PlayerID=LAMA_MasterID Then
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(LAMA_MasterID)
					LAMA_AddEvent(LAMA_PlayerRenamed,LAMA_P\ID,LAMA_P\Name)
					LAMA_P\Name=Name
					;absenden
					WriteByte LAMA_Stream,21
					WriteShort LAMA_Stream,LAMA_MasterID
					WriteString LAMA_Stream,Name
					LAMA_ISendUDPMsg(LAMA_Client)
				EndIf
		End Select
	EndIf
	
End Function
Function LAMA_BanPlayer(PlayerID,BanReason$,BanTime$)
	
	;variablen-vorbereiten
	Local LAMA_BListFile%,Time%
	;start
	If LAMA_Mode=LAMA_Host Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		If LAMA_P\On=True Then
			For LAMA_P.LAMA_Player=Each LAMA_Player
				If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID Then
					WriteByte LAMA_Stream,24
					WriteShort LAMA_Stream,PlayerID
					WriteString LAMA_Stream,BanReason
					LAMA_ISendUDPMsg(LAMA_Host)
				EndIf
			Next
			LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
			LAMA_P\On=False
			If Len(BanTime)=8 Then Time=Int(Left(BanTime,2))*3600000+Int(Mid(BanTime,4,2))*60000+Int(Right(BanTime,2))*1000
			If Time>0 Then
				LAMA_BL.LAMA_BList=New LAMA_BList
				LAMA_BL\IP=LAMA_P\IP
				LAMA_BL\MS=MilliSecs()+Time
			Else
				If FileType(LAMA_BanListPath+"banlist.lama")=0 Then
					LAMA_BListFile=WriteFile(LAMA_BanListPath+"banlist.lama")
				Else
					LAMA_BListFile=OpenFile(LAMA_BanListPath+"banlist.lama")
					While Eof(LAMA_BListFile)=0
						ReadString(LAMA_BListFile)
					Wend
				EndIf
				WriteString LAMA_BListFile,MD5(LAMA_P\IP)
				CloseFile LAMA_BListFile
			EndIf
			LAMA_ServerPlayers=LAMA_ServerPlayers-1
			LAMA_AddEvent(LAMA_PlayerBanned,PlayerID,BanReason)
		EndIf
	EndIf
	
End Function
Function LAMA_KickPlayer(PlayerID)
	
	If LAMA_Mode=LAMA_Host Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		If LAMA_P\On=True Then
			For LAMA_P.LAMA_Player=Each LAMA_Player
				If LAMA_P\On=True And LAMA_P\ID<>LAMA_MasterID Then
					WriteByte LAMA_Stream,22
					WriteShort LAMA_Stream,PlayerID
					LAMA_ISendUDPMsg(LAMA_Host)
				EndIf
			Next
			LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
			LAMA_P\On=False
			LAMA_K.LAMA_Kicks=LAMA_ISelectKicks(LAMA_P\IP)
			LAMA_K\Kicks=LAMA_K\Kicks+1
			LAMA_P\Kicks=LAMA_K\Kicks
			LAMA_ServerPlayers=LAMA_ServerPlayers-1
			LAMA_AddEvent(LAMA_PlayerKicked,PlayerID)
		EndIf
	EndIf
	
End Function

;ATTRIBUT-FUNKTIONEN
Function LAMA_ServerName$(ServerID=0)
	If ServerID=0 Then
		Return LAMA_ServerName
	Else If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\Name
	EndIf
End Function
Function LAMA_ServerMaxPlayers(ServerID=0)
	If ServerID=0 Then
		Return LAMA_ServerMaxPlayers
	Else If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\MaxPlayers
	EndIf
End Function
Function LAMA_ServerPlayers(ServerID=0)
	If ServerID=0 Then
		Return LAMA_ServerPlayers
	Else If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\Players
	EndIf
End Function
Function LAMA_ServerLocked(ServerID=0)
	If ServerID=0 Then
		Return LAMA_ServerLocked
	Else If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\Locked
	EndIf
End Function
Function LAMA_ServerPassword(ServerID=0)
	If ServerID=0 Then
		If LAMA_Password=LAMA_EmptyHash Then
			Return 0
		Else
			Return 1
		EndIf
	Else If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\Password
	EndIf
End Function
Function LAMA_ServerBannedFrom(ServerID=0)
	
	If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\BannedFrom
	EndIf
	
End Function
Function LAMA_ServerBanTime$(ServerID=0)
	
	If ServerID>0 Then
		LAMA_SL.LAMA_SList=Object.LAMA_SList(PeekInt(LAMA_SList,(ServerID-1)*4))
		If LAMA_SL<>Null Then Return LAMA_SL\BanTime
	EndIf
	
End Function

;EVENT
Function LAMA_Event%()
	LAMA_E.LAMA_IE=First LAMA_IE
	If LAMA_E.LAMA_IE<>Null Then
		LAMA_EventID%=LAMA_E\ID%
		LAMA_EventPlayerID%=LAMA_E\PlayerID%
		LAMA_EventInfo$=LAMA_E\Info$
		Delete LAMA_E
		Return 1
	Else
		LAMA_EventID%=0
		LAMA_EventGadgetID%=0
		LAMA_EventPlayerID%=0
	EndIf
End Function
Function LAMA_ClearEvents%()
	
	For LAMA_E.LAMA_IE=Each LAMA_IE
		Delete LAMA_E
	Next
	
End Function



;LAMA-INTERN
;---------------------------
;(NICHT-VERWENDEN! ANSONSTEN-EVENTUELL-FEHLER!)
Function LAMA_WriteIdent(Stream%,Value$)
	
	Local Ident%
	Ident=LAMA_Ident(Value)
	;WriteByte(Stream,Ident)
	Select Ident
		Case 1
			WriteByte(Stream,Int(Value))
		Case 2
			WriteShort(Stream,Int(Value))
		Case 3
			WriteInt(Stream,Int(Value))
		Case 4
			WriteFloat(Stream,Float(Value))
		Case 5
			WriteString(Stream,Value)
		Case 6
			WriteByte(Stream,Abs(Int(Value)))
		Case 7
			WriteShort(Stream,Abs(Int(Value)))
		Case 8
			WriteInt(Stream,Abs(Int(Value)))
	End Select
	
End Function
Function LAMA_ReadIdent$(Stream%,Ident%)
	
	Select Ident
		Case 1
			Return ReadByte(Stream)
		Case 2
			Return ReadShort(Stream)
		Case 3
			Return ReadInt(Stream)
		Case 4
			Return ReadFloat(Stream)
		Case 5
			Return ReadString(Stream)
		Case 6
			Return -ReadByte(Stream)
		Case 7
			Return -ReadShort(Stream)
		Case 8
			Return -ReadInt(Stream)
	End Select
	
End Function
Function LAMA_ICountAll()
	
	;variablen-vorbereiten
	Local i%
	LAMA_CountTransfers=0
	;zhlwerk
	For LAMA_F.LAMA_FTr=Each LAMA_FTr;dateibertragungen
		LAMA_CountTransfers=LAMA_CountTransfers+1
	Next
	If LAMA_CountTransfersO<>LAMA_CountTransfers And (LAMA_CountTransfersO+LAMA_CountTransfers)>0 Then
		Dim LAMA_TransferPath$(LAMA_CountTransfers)
		Dim LAMA_TransferProgress#(LAMA_CountTransfers)
		Dim LAMA_TransferMode%(LAMA_CountTransfers)
		Dim LAMA_TransferSize%(LAMA_CountTransfers)
		Dim LAMA_TransferT_ID(LAMA_CountTransfers)
		For LAMA_F.LAMA_FTr=Each LAMA_FTr;dateibertragungen
			i=i+1
			LAMA_TransferPath(i)=LAMA_F\Path
			LAMA_TransferProgress#(i)=LAMA_F\Prg
			LAMA_TransferMode%(i)=LAMA_F\Mode
			LAMA_TransferSize%(i)=LAMA_F\Byt
			LAMA_TransferT_ID(i)=Handle(LAMA_F.LAMA_FTr)
		Next
	EndIf
	If LAMA_Password=LAMA_EmptyHash Then
		LAMA_ServerPassword=False
	Else
		LAMA_ServerPassword=True
	EndIf
	For LAMA_BL.LAMA_BList=Each LAMA_BList
		If LAMA_BL\MS<MilliSecs() Then
			Delete LAMA_BL.LAMA_BList
		EndIf
	Next
	
End Function
Function LAMA_ISelectPlayer.LAMA_Player(P_ID)
	
	Return Object.LAMA_Player(PeekInt(LAMA_PH,(P_ID-1)*4))
	
End Function
Function LAMA_IStorePlayer(LAMA_P.LAMA_Player,P_ID)
	
	PokeInt(LAMA_PH,(P_ID-1)*4,Handle(LAMA_P.LAMA_Player))
	
End Function
Function LAMA_ISend()
	
	;variablen-vorbereiten
	Local uaccess1
	Local uaccess2
	Local LAMA_TM.LAMA_NSend
	
	;variablen-vorbereiten-teil2
	For LAMA_P.LAMA_Player=Each LAMA_Player
		If LAMA_P\ID<>LAMA_MasterID Then
			For LAMA_MM.LAMA_MSend=Each LAMA_MSend
				If LAMA_MM\F_ID<>LAMA_P\ID Then
					LAMA_NM.LAMA_NSend=New LAMA_NSend
					LAMA_NM\P_ID=LAMA_P\ID
					LAMA_NM\F_ID=LAMA_MM\F_ID
					LAMA_NM\M_ID=LAMA_MM\M_ID
					LAMA_NM\Sec=LAMA_MM\Sec
					LAMA_NM\V=LAMA_MM\V
					LAMA_NM\Cut=LAMA_MM\Cut
				EndIf
			Next
		EndIf
	Next
	;temporre-speicher-lschen
	For LAMA_MM.LAMA_MSend=Each LAMA_MSend
		Delete LAMA_MM
	Next
	;nachrichten-bearbeiten
	For LAMA_NM.LAMA_NSend=Each LAMA_NSend
		If LAMA_NM\Sec And LAMA_NM\S_ID=0 Then
			If (LAMA_NM\Cut Mod 2)=1 Then LAMA_S_ID=(LAMA_S_ID+1) Mod 65535
			LAMA_NM\S_ID=LAMA_S_ID+1
		EndIf
		If (LAMA_NM\Cut Mod 2)=1 Then
			LAMA_TM.LAMA_NSend=Before LAMA_NM.LAMA_NSend
			If LAMA_TM<>Null Then
				If LAMA_TM\Cut<2 Then LAMA_TM\Cut=LAMA_TM\Cut+2
			EndIf
		EndIf
		If LAMA_NM.LAMA_NSend=Last LAMA_NSend Then
			If LAMA_NM\Cut<2 Then LAMA_NM\Cut=LAMA_NM\Cut+2
		EndIf
	Next
	
	;NUR-AUS-PRFZWECKEN
;	u=0
;	For LAMA_NM.LAMA_NSend=Each LAMA_NSend
;		Text 300,100+u*15,LAMA_NM\Cut+" - "+LAMA_NM\P_ID+" - "+LAMA_NM\Sec+" : "+LAMA_NM\S_ID
;		u=u+1
;	Next
;	u=u+1
;	For LAMA_RS.LAMA_RSec=Each LAMA_RSec
;		Text 200,100+u*15,LAMA_RS\P_ID+" - "+LAMA_RS\S_ID+" : "+LAMA_RS\MS
;		u=u+1
;	Next
	
	;sendeblock-funktion
	For LAMA_NM.LAMA_NSend=Each LAMA_NSend
		If LAMA_NM\P_ID>0 Then uaccess1=LAMA_Online(LAMA_NM\P_ID)
		If (uaccess1 Or (LAMA_Mode=2 And LAMA_NM\P_ID=0)) And LAMA_NM\MS<MilliSecs() Then
			If (LAMA_NM\Cut Mod 2)=1 Then
				WriteByte LAMA_Stream,13
				WriteShort LAMA_Stream,LAMA_NM\F_ID;von
				WriteShort LAMA_Stream,LAMA_NM\P_ID;an
				WriteShort LAMA_Stream,LAMA_NM\M_ID;msgid
				WriteShort LAMA_Stream,LAMA_NM\S_ID;sicherid
				If LAMA_NM\Sec Then uaccess2=MilliSecs()+LAMA_SecInterV
			EndIf
			WriteByte LAMA_Stream,(LAMA_NM\Cut*10+LAMA_Ident(LAMA_NM\V));cut
			LAMA_WriteIdent(LAMA_Stream,LAMA_NM\V)
			If LAMA_NM\Cut>1 Then
				Select LAMA_Mode
					Case LAMA_Host
						SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
					Case LAMA_Client
						SendUDPMsg LAMA_Stream,LAMA_SIP,LAMA_Port
				End Select
			EndIf
			LAMA_NM\MS=uaccess2
			LAMA_NM\Tr=LAMA_NM\Tr+1
			If LAMA_NM\Sec=False Or LAMA_NM\Tr=LAMA_S_Tr Then
				Delete LAMA_NM
			EndIf
		Else
			Delete LAMA_NM
		EndIf
	Next		
	
End Function
Function LAMA_IRecv()
	
	;variablen-vorbereiten
	Local uaccess1
	Local uaccess2
	Local uaccess3
	Local uaccess4
	Local uaccess6
	Local uaccess7
	Local uaccess8
	Local uaccess9
	Local V$,i,Cut%
	;empfangen-13
	uaccess1=ReadShort(LAMA_Stream);von
	uaccess2=ReadShort(LAMA_Stream);an
	uaccess3=ReadShort(LAMA_Stream);msgid
	uaccess7=ReadShort(LAMA_Stream);sicherid
	
	;antwort-senden
	If uaccess7>0 Then
		uaccess8=LAMA_Online(uaccess1)
		If uaccess8 Then
			WriteByte LAMA_Stream,14;antwort
			WriteShort LAMA_Stream,LAMA_MasterID;von
			WriteShort LAMA_Stream,uaccess1;an
			WriteShort LAMA_Stream,uaccess7;sicherid
			Select LAMA_Mode
				Case LAMA_Host
					SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
				Case LAMA_Client
					SendUDPMsg LAMA_Stream,LAMA_SIP,LAMA_Port
			End Select
		EndIf
	EndIf
	
	If uaccess2=0 Then;an-alle-spieler
		uaccess6=LAMA_IExist(uaccess1,uaccess7)
		Repeat
			uaccess9=ReadByte(LAMA_Stream);byte
			Cut=uaccess9/10
			V=LAMA_ReadIdent(LAMA_Stream,(uaccess9 Mod 10))
			
			;DOPPELTER-EMPFANG-AUS
			If uaccess7>0 Then
				If uaccess6=0 Then
					LAMA_IAddMsg(uaccess1,uaccess3,V)
					;sicher-speichern
					LAMA_IAddExist(uaccess1,uaccess7)
				Else
					LAMA_IUpdateExist(uaccess1,uaccess7);zhler-zurcksetzen
				EndIf
			Else
				LAMA_IAddMsg(uaccess1,uaccess3,V)
			EndIf
			
			LAMA_MM.LAMA_MSend=New LAMA_MSend
			LAMA_MM\F_ID=uaccess1
			LAMA_MM\M_ID=uaccess3
			LAMA_MM\V=V
			LAMA_MM\Cut=Cut
			If uaccess7>0 Then LAMA_MM\Sec=True
		Until Cut>1
	Else;an-einen-bestimmten-spieler
		uaccess4=LAMA_Online(uaccess2)
		;nachrichten-weiterleiten/speichern
		If uaccess2<>LAMA_MasterID And uaccess4 Then
			WriteByte LAMA_Stream,13
			WriteShort LAMA_Stream,uaccess1;von
			WriteShort LAMA_Stream,uaccess2;an
			WriteShort LAMA_Stream,uaccess3;msgid
			WriteShort LAMA_Stream,uaccess7;sicherid
		EndIf
		Repeat
			uaccess9=ReadByte(LAMA_Stream);byte
			Cut=uaccess9/10
			V=LAMA_ReadIdent(LAMA_Stream,(uaccess9 Mod 10))
			
			If uaccess2=LAMA_MasterID Then
				;DOPPELTER-EMPFANG-AUS
				If uaccess7>0 Then
					If LAMA_IExist(uaccess1,uaccess7)=0 Then
						LAMA_IAddMsg(uaccess1,uaccess3,V)
						;sicher-speichern
						If Cut>1 Then LAMA_IAddExist(uaccess1,uaccess7)
					Else
						LAMA_IUpdateExist(uaccess1,uaccess7);zhler-zurcksetzen
					EndIf
				Else
					LAMA_IAddMsg(uaccess1,uaccess3,V)
				EndIf
			Else;weiterleiten
				If uaccess4 Then
					WriteByte LAMA_Stream,(Cut*10+LAMA_Ident(V))
					LAMA_WriteIdent(LAMA_Stream,V)
				EndIf
				If Cut>1 And uaccess4 Then
					SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
				EndIf
			EndIf
		Until Cut>1
	EndIf
	
End Function
Function LAMA_ITFile();senden
	
	;variablen-bearbeiten
	Local uaccess1
	Local uaccess2
	Local i%
	;sendefunktionen
	For LAMA_F.LAMA_FTr=Each LAMA_FTr
		uaccess1=LAMA_Online(LAMA_F\P_ID)
		If LAMA_F\MS<MilliSecs() And LAMA_F\Mode=LAMA_FSend And uaccess1=True Then
			Select LAMA_F\Cut
				Case 0
					;daten-schreiben
					WriteByte LAMA_Stream,18
					WriteByte LAMA_Stream,0
					WriteShort LAMA_Stream,LAMA_MasterID;von
					WriteShort LAMA_Stream,LAMA_F\P_ID;an
					WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
					WriteInt LAMA_Stream,LAMA_F\Byt;gesamt-bytes
					WriteString LAMA_Stream,LAMA_F\Path;dateiname
					;senden
					LAMA_ISendUDPMsg()
				Case 1
					uaccess2=LAMA_PackageS;byte-anzahl-bestimmung
					If uaccess2>(LAMA_F\Byt-FilePos(LAMA_F\Stream)) Then
						uaccess2=LAMA_F\Byt-FilePos(LAMA_F\Stream)
					EndIf
					;daten-schreiben
					WriteByte LAMA_Stream,18
					WriteByte LAMA_Stream,1
					WriteShort LAMA_Stream,LAMA_MasterID;von
					WriteShort LAMA_Stream,LAMA_F\P_ID;an
					WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
					WriteShort LAMA_Stream,uaccess2;bytes
					WriteInt LAMA_Stream,FilePos(LAMA_F\Stream);bytes
					;bytes-schreiben
					For i=1 To uaccess2
						WriteByte LAMA_Stream,ReadByte(LAMA_F\Stream)
					Next
					;position-zurcksetzen-fr-neuversuche
					SeekFile LAMA_F\Stream,FilePos(LAMA_F\Stream)-uaccess2
					;senden
					LAMA_ISendUDPMsg()
				Case 2;datei-bertragung-abschlieen
					LAMA_AddEvent(LAMA_TransmittedFile,LAMA_F\P_ID,LAMA_F\Path)
					WriteByte LAMA_Stream,19;antwortbyte
					WriteByte LAMA_Stream,2
					WriteShort LAMA_Stream,LAMA_MasterID;von
					WriteShort LAMA_Stream,LAMA_F\P_ID;an
					WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
					;senden
					LAMA_ISendUDPMsg()
					If LAMA_F\Stream>0 Then CloseFile LAMA_F\Stream:LAMA_F\Stream=0
			End Select
			
			LAMA_F\MS=MilliSecs()+LAMA_FileInterV
			LAMA_F\Tr=LAMA_F\Tr+1
		Else If LAMA_F\MS<MilliSecs() And LAMA_F\Mode=LAMA_FRecv Then
			LAMA_F\MS=MilliSecs()+LAMA_FileInterV
			LAMA_F\Tr=LAMA_F\Tr+1
		EndIf
		;datentransfer-abbrechen
		If LAMA_F\Tr=LAMA_F_Tr Or (uaccess1=False And LAMA_F\Mode=LAMA_FSend) Or LAMA_F\Cut=2 Then
			If LAMA_F\Tr=LAMA_F_Tr Then
				LAMA_AddEvent(LAMA_TransferFailed,LAMA_F\P_ID,LAMA_F\Path)
			EndIf
			Delete LAMA_F.LAMA_FTr
		EndIf
	Next
	
End Function
Function LAMA_IRFile();empfangen
	
	;variablen-bearbeiten
	Local uaccess1
	Local uaccess2
	Local uaccess3
	Local uaccess4
	Local uaccess5
	Local Path$,Cut%,i%
	Local CurDir$
	;daten-einlesen
	Cut=ReadByte(LAMA_Stream);cut
	uaccess1=ReadShort(LAMA_Stream);von
	uaccess2=ReadShort(LAMA_Stream);an
	uaccess3=ReadShort(LAMA_Stream);transferid
	Select Cut
		Case 0
			uaccess4=ReadInt(LAMA_Stream);gesamt-bytes
			Path=ReadString(LAMA_Stream);dateipfad
		Case 1
			uaccess4=ReadShort(LAMA_Stream);bytes
			uaccess5=ReadInt(LAMA_Stream);position
		Case 3
			Path=ReadString(LAMA_Stream);unterverzeichnis
	End Select
	Select Cut
		Case 0;datei-bertragung-beginnen
			;empfangen/weiterleiten
			If uaccess2<>LAMA_MasterID Then
				LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess2)
				If LAMA_P\On=True Then
					WriteByte LAMA_Stream,18
					WriteByte LAMA_Stream,Cut
					WriteShort LAMA_Stream,uaccess1
					WriteShort LAMA_Stream,uaccess2
					WriteShort LAMA_Stream,uaccess3
					WriteInt LAMA_Stream,uaccess4
					WriteString LAMA_Stream,Path$
					;senden
					SendUDPMsg(LAMA_Stream,LAMA_P\IP,LAMA_P\Port)
				EndIf
			Else
				If LAMA_TFRecvExist(uaccess1,uaccess3)=0 Then
					LAMA_F.LAMA_FTr=New LAMA_FTr
					Path=LAMA_SavingPath+Path
					Path=LAMA_IRename(Path)
					CurDir=CurrentDir()
					ChangeDir Path
					LAMA_F\Stream=WriteFile(Path)
					ChangeDir CurDir
					LAMA_F\Mode=LAMA_FRecv
					LAMA_F\P_ID=uaccess1
					LAMA_F\T_ID=uaccess3
					LAMA_F\Byt=uaccess4
					LAMA_F\Path=Path
					LAMA_F\Pos=-1
					LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
				Else
					While Eof(LAMA_Stream)=0
						ReadByte(LAMA_Stream)
					Wend
				EndIf
				;antwort-senden
				If LAMA_P\On=True Then
					WriteByte LAMA_Stream,19;antwortbyte
					WriteByte LAMA_Stream,Cut
					WriteShort LAMA_Stream,LAMA_MasterID;von
					WriteShort LAMA_Stream,LAMA_F\P_ID;an
					WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
						;senden
					LAMA_ISendUDPMsg()
				EndIf
			EndIf
		Case 1;datei-erhalten
			;empfangen/weiterleiten
			If uaccess2<>LAMA_MasterID Then
				LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess2)
				If LAMA_P\On=True Then
					WriteByte LAMA_Stream,18
					WriteByte LAMA_Stream,Cut
					WriteShort LAMA_Stream,uaccess1;von
					WriteShort LAMA_Stream,uaccess2;an
					WriteShort LAMA_Stream,uaccess3;transferid
					WriteShort LAMA_Stream,uaccess4;bytes
					WriteInt LAMA_Stream,uaccess5;position
					;bytes-weiterleiten
					For i=1 To uaccess4
						WriteByte LAMA_Stream,ReadByte(LAMA_Stream)
					Next
					;senden
					SendUDPMsg(LAMA_Stream,LAMA_P\IP,LAMA_P\Port)
				Else;wenn-empf.-offline-einfach-so-auslesen
					While Eof(LAMA_Stream)=0
						ReadByte(LAMA_Stream)
					Wend
				EndIf
			Else
				For LAMA_F.LAMA_FTr=Each LAMA_FTr
					If LAMA_F\P_ID=uaccess1 And LAMA_F\T_ID=uaccess3 And LAMA_F\Mode=LAMA_FRecv Then
						;bytes-lesen/schreiben
						If uaccess5<>LAMA_F\Pos Then
							SeekFile LAMA_F\Stream,uaccess5
							For i=1 To uaccess4
								WriteByte LAMA_F\Stream,ReadByte(LAMA_Stream)
							Next
							LAMA_F\Prg=Float(FilePos(LAMA_F\Stream))/Float(LAMA_F\Byt)
							LAMA_F\Pos=uaccess5
						Else;wenn-diese-bytes-schon-erhalten-wurden-und-doppelt-ankommen-sollten
							For i=1 To uaccess4
								ReadByte(LAMA_Stream)
							Next
						EndIf
						LAMA_F\Tr=0
						LAMA_F\MS=0
						LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
						;antwort-senden
						If LAMA_P\On=True Then
							WriteByte LAMA_Stream,19;antwortbyte
							WriteByte LAMA_Stream,Cut
							WriteShort LAMA_Stream,LAMA_MasterID;von
							WriteShort LAMA_Stream,LAMA_F\P_ID;an
							WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
							;senden
							LAMA_ISendUDPMsg()
						EndIf
						;schleife-verlassen
						Exit
					EndIf
				Next
			EndIf
	End Select
	
End Function
Function LAMA_IAFile();antworten
	
	;variablen-vorbereiten
	Local uaccess1
	Local uaccess2
	Local uaccess3
	Local Cut%
	;anfang
	Cut=ReadByte(LAMA_Stream);cut-wert
	uaccess1=ReadShort(LAMA_Stream);von
	uaccess2=ReadShort(LAMA_Stream);an
	uaccess3=ReadShort(LAMA_Stream);transferid
	;empfangen/weiterleiten
	If uaccess2<>LAMA_MasterID Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess2)
		If LAMA_P\On=True Then
			WriteByte LAMA_Stream,19
			WriteByte LAMA_Stream,Cut;cut
			WriteShort LAMA_Stream,uaccess1;von
			WriteShort LAMA_Stream,uaccess2;an
			WriteShort LAMA_Stream,uaccess3;transferid
			SendUDPMsg(LAMA_Stream,LAMA_P\IP,LAMA_P\Port)
		EndIf
	Else
		Select Cut
			Case 0;datei-bertragung-beginnen
				;antwort-registrieren
				For LAMA_F.LAMA_FTr=Each LAMA_FTr
					If LAMA_F\P_ID=uaccess1 And LAMA_F\T_ID=uaccess3 And LAMA_F\Mode=LAMA_FSend Then
						LAMA_F\Cut=1
						LAMA_F\Tr=0
						LAMA_F\MS=0
						Return 0
					EndIf
				Next
			Case 1;paket-fertig-bertragen(empf.sender)
				;antwort-registrieren
				For LAMA_F.LAMA_FTr=Each LAMA_FTr
					If LAMA_F\P_ID=uaccess1 And LAMA_F\T_ID=uaccess3 And LAMA_F\Mode=LAMA_FSend Then
						If FilePos(LAMA_F\Stream)+LAMA_PackageS>=LAMA_F\Byt Then
							LAMA_F\Cut=2;datei-bertragung-abschlieen
						Else
							SeekFile LAMA_F\Stream,FilePos(LAMA_F\Stream)+LAMA_PackageS
						EndIf
						LAMA_F\Prg=Float(FilePos(LAMA_F\Stream))/Float(LAMA_F\Byt)
						LAMA_F\Tr=0
						LAMA_F\MS=0
						Return 0
					EndIf
				Next
			Case 2;abschlieen(empf.empfnger)
				For LAMA_F.LAMA_FTr=Each LAMA_FTr
					If LAMA_F\P_ID=uaccess1 And LAMA_F\T_ID=uaccess3 And LAMA_F\Mode=LAMA_FRecv Then
						LAMA_AddEvent(LAMA_ReceivedFile,LAMA_F\P_ID,LAMA_F\Path)
						CloseFile(LAMA_F\Stream)
						Delete LAMA_F.LAMA_FTr
						Return 0
					EndIf
				Next
			Case 3;bertragung abgebrochen
				For LAMA_F.LAMA_FTr=Each LAMA_FTr
					If LAMA_F\P_ID=uaccess1 And LAMA_F\T_ID=uaccess3 Then
						CloseFile(LAMA_F\Stream)
						If LAMA_F\Mode=LAMA_FRecv Then DeleteFile LAMA_F\Path
						LAMA_AddEvent(LAMA_TransferCanceled,LAMA_F\P_ID,LAMA_F\Path)
						Delete LAMA_F.LAMA_FTr
						Return 0
					EndIf
				Next
		End Select
	EndIf
	
End Function
Function LAMA_TFSendExist(P_ID,T_ID)
	
	For LAMA_F.LAMA_FTr=Each LAMA_FTr
		If LAMA_F\P_ID=P_ID And LAMA_F\T_ID=T_ID And LAMA_F\Mode=LAMA_FSend Then Return 1
	Next
	Return 0
	
End Function
Function LAMA_TFRecvExist(P_ID,T_ID)
	
	For LAMA_F.LAMA_FTr=Each LAMA_FTr
		If LAMA_F\P_ID=P_ID And LAMA_F\T_ID=T_ID And LAMA_F\Mode=LAMA_FRecv Then Return 1
	Next
	Return 0
	
End Function
Function LAMA_IAddMsg(F_ID%,M_ID%,V$)
	LAMA_RM.LAMA_RMsg=New LAMA_RMsg
	LAMA_RM\F_ID=F_ID;von
	LAMA_RM\M_ID=M_ID;msgid
	LAMA_RM\V=V
End Function
Function LAMA_IAddExist(P_ID,S_ID)
	
	LAMA_RS.LAMA_RSec=New LAMA_RSec
	LAMA_RS\P_ID=P_ID
	LAMA_RS\S_ID=S_ID
	LAMA_RS\MS=MilliSecs()+LAMA_SecInterV*2
	
End Function
Function LAMA_IExist(P_ID,S_ID)
	
	For LAMA_RS.LAMA_RSec=Each LAMA_RSec
		If LAMA_RS\P_ID=P_ID And LAMA_RS\S_ID=S_ID Then Return 1
	Next
	Return 0
	
End Function
Function LAMA_IUpdateExist(P_ID,S_ID)
	
	For LAMA_RS.LAMA_RSec=Each LAMA_RSec
		If LAMA_RS\P_ID=P_ID And LAMA_RS\S_ID=S_ID Then LAMA_RS\MS=MilliSecs()+LAMA_SecInterV*2:Exit
	Next
	
End Function
Function LAMA_IUpdateExists()
	
	For LAMA_RS.LAMA_RSec=Each LAMA_RSec
		If LAMA_RS\MS<MilliSecs() Then Delete LAMA_RS
	Next
	
End Function
Function LAMA_ITOut(PlayerID)
	
	Local LAMA_PI.LAMA_Player
	If PlayerID>0 And PlayerID<=LAMA_ServerMaxPlayers Then
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(PlayerID)
		If LAMA_P\On=True Then
			For LAMA_PI.LAMA_Player=Each LAMA_Player
				If LAMA_PI\ID<>LAMA_MasterID And LAMA_PI\ID<>PlayerID And LAMA_PI\On=True Then
					WriteByte LAMA_Stream,15
					WriteShort LAMA_Stream,PlayerID
					SendUDPMsg LAMA_Stream,LAMA_PI\IP,LAMA_PI\Port
				EndIf
			Next
			LAMA_P\On=False
			LAMA_ServerPlayers=LAMA_ServerPlayers-1
			LAMA_AddEvent(LAMA_PlayerLeft,PlayerID)
			If LAMA_ServerPlayers=0 Then
				LAMA_Connection=False
			EndIf
		EndIf
	EndIf
	
End Function
Function LAMA_IFreePlayer(P_ID)
	
	LAMA_P.LAMA_Player=LAMA_ISelectPlayer(P_ID)
	LAMA_P\On=False
	LAMA_ServerPlayers=LAMA_ServerPlayers-1
	
End Function
Function LAMA_IFreeAllPlayers()
	
	For LAMA_P.LAMA_Player=Each LAMA_Player
		LAMA_P\On=False
	Next
	LAMA_ServerPlayers=0
	LAMA_ServerMaxPlayers=0
	
End Function
Function LAMA_ICreateAllPlayers(MaxPLayers)
	
	Local uaccess1
	;vorhandene-spieler-eintrge-lschen
	For LAMA_P.LAMA_Player=Each LAMA_Player
		Delete LAMA_P
	Next
	;spieler-erstellen
	For uaccess1=1 To MaxPLayers
		LAMA_P.LAMA_Player=New LAMA_Player
		LAMA_P\ID=uaccess1
			;handlewert-speichern
		LAMA_IStorePlayer(LAMA_P,LAMA_P\ID)
	Next
	
End Function
Function LAMA_IPing()
	;PING
	Local LAMA_IntP.LAMA_Player
	Select LAMA_Mode
		Case LAMA_Host
			For LAMA_P.LAMA_Player=Each LAMA_Player
				If LAMA_P\ID<>LAMA_MasterID And LAMA_P\On=True Then
					If LAMA_P\TPingC>=LAMA_PingIV Then
						LAMA_P\Ping=LAMA_P\TPing/LAMA_P\TPingC
						LAMA_P\TPing=0
						LAMA_P\TPingC=0
						
						WriteByte LAMA_Stream,10
						For LAMA_IntP.LAMA_Player=Each LAMA_Player
							If LAMA_IntP\ID<>LAMA_MasterID And LAMA_IntP\On=True Then
								WriteByte LAMA_Stream,1
								WriteShort LAMA_Stream,LAMA_IntP\ID
								WriteShort LAMA_Stream,LAMA_IntP\Ping
							EndIf
						Next
						WriteByte LAMA_Stream,0
						SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
					EndIf
					If LAMA_P\PingOK=False Then
						LAMA_P\MSecs=MilliSecs()
						LAMA_P\PingOK=True
					Else
						LAMA_P\TPing=LAMA_P\TPing+(MilliSecs()-LAMA_P\MSecs)
						LAMA_P\TPingC=LAMA_P\TPingC+1
					EndIf
					WriteByte LAMA_Stream,8
					SendUDPMsg LAMA_Stream,LAMA_P\IP,LAMA_P\Port
				EndIf
			Next
			If LAMA_PingMS<MilliSecs() Then LAMA_PingMS=MilliSecs()+LAMA_PingIV
		Case LAMA_Client
			If LAMA_TPingC>=LAMA_PingIV% Then
				LAMA_SPing=LAMA_TPing/LAMA_TPingC
				LAMA_P.LAMA_Player=LAMA_ISelectPlayer(LAMA_MasterID)
				LAMA_P\Ping=LAMA_SPing
				;server-player-ping
				LAMA_P.LAMA_Player=LAMA_ISelectPlayer(LAMA_HostID)
				LAMA_P\Ping=LAMA_SPing
				LAMA_TPing=0
				LAMA_TPingC=0
			EndIf
			If LAMA_PingOK=False Then
				LAMA_PingMS=MilliSecs()
				LAMA_PingOK=True
			Else
				LAMA_TPing=LAMA_TPing+(MilliSecs()-LAMA_PingMS)
				LAMA_TPingC=LAMA_TPingC+1
			EndIf
			WriteByte LAMA_Stream,11
			SendUDPMsg LAMA_Stream,LAMA_SIP,LAMA_Port
	End Select
	For LAMA_P.LAMA_Player=Each LAMA_Player
		If LAMA_P\Ping>LAMA_TOut And LAMA_P\On=True Then LAMA_ITOut(LAMA_P\ID)
	Next
	
End Function
Function LAMA_Ask_IPBanned(IP%)
	
	Local LAMA_BL.LAMA_BList
	Local LAMA_BListFile
	;bannlist-type-eintrge-untersuchen
	For LAMA_BL.LAMA_BList=Each LAMA_BList
		If LAMA_BL\IP=IP Then Return True
	Next
	;banlist-datei-untersuchen
	If FileType(LAMA_BanListPath+"banlist.lama")=1 Then
		LAMA_BListFile=ReadFile(LAMA_BanListPath+"banlist.lama")
		If LAMA_BListFile>0 Then
			While Eof(LAMA_BListFile)=0
				If ReadString(LAMA_BListFile)=MD5(IP) Then
					CloseFile LAMA_BListFile
					Return True
				EndIf
			Wend
		EndIf
	EndIf
	Return False
	
End Function
Function LAMA_Ask_IPBanTime$(IP%)
	
	;variablen-vorbereiten
	Local Time$,MS%,S%,M%,H%
	;bannlist-type-eintrge-untersuchen
	For LAMA_BL.LAMA_BList=Each LAMA_BList
		If LAMA_BL\IP=IP Then
			MS=MilliSecs()-LAMA_BL\MS
			S=MS/1000
			While S>59
				M=M+1
				S=S-60
			Wend
			While M>59
				H=H+1
				M=M-60
			Wend
			If H<10 Then
				Time$="0"+H+":"
			Else
				Time$=H+":"
			EndIf
			If M<10 Then
				Time$=Time$+"0"+M+":"
			Else
				Time$=Time$+M+":"
			EndIf
			If S<10 Then
				Time$=Time$+"0"+S
			Else
				Time$=Time$+S
			EndIf
			Return Time$
		EndIf
	Next
	
End Function
Function LAMA_Ask_PlayerSpace()
	Local uaccess1,LAMA_P.LAMA_Player
	For uaccess1=1 To LAMA_ServerMaxPlayers
		LAMA_P.LAMA_Player=LAMA_ISelectPlayer(uaccess1)
		If LAMA_P\On=False Then Return uaccess1
	Next
	Return 0
End Function
Function LAMA_AddEvent(EventID%,PlayerID%=0,Info$="")
	
	LAMA_E.LAMA_IE=New LAMA_IE
	LAMA_E\ID=EventID
	LAMA_E\PlayerID=PlayerID
	LAMA_E\Info=Info
	
End Function
Function LAMA_Ident(Value$)
	Local IntValue=Int(Value$)
	If Value$<>"" Then
		If Str(IntValue)=Value$ Then
			If IntValue>=0 Then
				If IntValue<256 Then
					Return 1
				Else If IntValue<65536 Then
					Return 2
				Else
					Return 3
				EndIf
			Else
				If Abs(IntValue)<256 Then
					Return 6
				Else If Abs(IntValue)<65536 Then
					Return 7
				Else
					Return 8
				EndIf
			EndIf
		Else If Str(Float(Value$))=Value$ Then
			Return 4
		Else
			Return 5
		EndIf
	Else
		Return 5
	EndIf
End Function
Function LAMA_ISendUDPMsg(Mode%=0)
	Select Mode
		Case 0
			Select LAMA_Mode
				Case LAMA_Host
					SendUDPMsg(LAMA_Stream,LAMA_P\IP,LAMA_P\Port)
				Case LAMA_Client
					SendUDPMsg(LAMA_Stream,LAMA_SIP,LAMA_Port)
			End Select
		Case LAMA_Host
			SendUDPMsg(LAMA_Stream,LAMA_P\IP,LAMA_P\Port)
		Case LAMA_Client
			SendUDPMsg(LAMA_Stream,LAMA_SIP,LAMA_Port)
	End Select
End Function
Function LAMA_ISelectKicks.LAMA_Kicks(IP)
	
	For LAMA_K.LAMA_Kicks=Each LAMA_Kicks
		If LAMA_K\IP=IP Then Return LAMA_K.LAMA_Kicks
	Next
	LAMA_K.LAMA_Kicks=New LAMA_Kicks
	LAMA_K\IP=IP
	Return LAMA_K.LAMA_Kicks
		
End Function
Function LAMA_IDynamicSList()
	
	;variablen-vorbereiten
	Local uaccess1
	;start
	If LAMA_Mode=LAMA_Host Then
		For LAMA_DSL.LAMA_DSList=Each LAMA_DSList
			If LAMA_IDynamicIsPlayer(LAMA_DSL\IP,LAMA_DSL\Port)=0 Then
				If LAMA_DSL\MS<MilliSecs() Then
					WriteByte LAMA_Stream,26
					WriteString LAMA_Stream,LAMA_ServerName
					WriteShort LAMA_Stream,LAMA_ServerMaxPlayers
					WriteShort LAMA_Stream,LAMA_ServerPlayers
					WriteByte LAMA_Stream,LAMA_ServerPassword
					WriteByte LAMA_Stream,LAMA_ServerLocked
					uaccess1=LAMA_Ask_IPBanned(LAMA_DSL\IP)
					WriteByte LAMA_Stream,uaccess1
					WriteString LAMA_Stream,LAMA_Ask_IPBanTime(LAMA_DSL\IP)
					;server-informationen
					For uaccess1=1 To (BankSize(LAMA_SInfo))/4
						LAMA_SI.LAMA_SInfo=Object.LAMA_SInfo(PeekInt(LAMA_SInfo,(uaccess1*4)-4))
						If LAMA_SI.LAMA_SInfo<>Null Then
							WriteByte LAMA_Stream,LAMA_Ident(LAMA_SI\Info)
							WriteByte LAMA_Stream,uaccess1
							LAMA_WriteIdent(LAMA_Stream,LAMA_SI\Info)
						EndIf
					Next
					WriteByte LAMA_Stream,255
					SendUDPMsg LAMA_Stream,LAMA_DSL\IP,LAMA_DSL\Port
					
					LAMA_DSL\MS=MilliSecs()+500
					LAMA_DSL\Tr=LAMA_DSL\Tr+1
					If LAMA_DSL\Tr=20 Then Delete LAMA_DSL.LAMA_DSList
				EndIf
			Else
				Delete LAMA_DSL.LAMA_DSList
			EndIf
		Next
	EndIf
	
End Function
Function LAMA_IDynamicIsPlayer(IP%,Port%)
	
	For LAMA_P.LAMA_Player=Each LAMA_Player
		If IP=LAMA_P\IP And Port=LAMA_P\Port And LAMA_P\On=True Then Return 1
	Next
	Return 0
	
End Function
Function LAMA_ISelectDSL.LAMA_DSList(IP%,Port%)
	
	For LAMA_DSL.LAMA_DSList=Each LAMA_DSList
		If LAMA_DSL\IP=IP And LAMA_DSL\Port=Port Then Return LAMA_DSL.LAMA_DSList
	Next
	LAMA_DSL.LAMA_DSList=New LAMA_DSList
	LAMA_DSL\IP=IP
	LAMA_DSL\Port=Port
	Return LAMA_DSL.LAMA_DSList
	
End Function
Function LAMA_IClearStream(Stream%)
	
	If Stream>0 Then
		While Eof(Stream)=0
			ReadByte(Stream)
		Wend
	EndIf
	
End Function
;DATEI-ORDNER-NAMEN-HERAUSFINDEN
Function LAMA_IFileName$(Path$,Returns%=0)
	Local FName$,FEnding$
	Local Ending$=Right(Path$,5),i
	For i=1 To 5
		If Mid(Ending,6-i,1)="." Then
			FEnding$=Mid(Ending,7-i,-1)
			Exit
		EndIf
	Next
	For i=1 To Len(Path$)
		If Mid(Path$,Len(Path$)+1-i,1)="\" Or Mid(Path$,Len(Path$)+1-i,1)="/" Then
			FName$=Mid(Path$,Len(Path$)+2-i,-1)
			FName$=Replace(FName$,"."+FEnding$,"")
			Exit
		EndIf
	Next
	If FName$="" Then FName$=Replace(Path$,"."+FEnding$,"")
	Select Returns
		Case 0
			Return FName$+"."+FEnding$
		Case 1
			Return FName$
		Case 2
			Return FEnding$
		Case 3;Pfad-ohne-namen-oder-endung
			Return Replace(Path$,FName$+"."+FEnding$,"")
	End Select
End Function
Function LAMA_IFolderName$(Path$,Returns%=0)
	
	Local Pos%
	If Instr(Path,"/")=0 And Instr(Path,"\")=0 Then
		Return Path$
	Else
		Pos=Len(Path)
		Repeat
			If Mid(Path,Pos,1)="/" Or Mid(Path,Pos,1)="\" Then
				Return Mid(Path,Pos+1,-1)
			EndIf
			Pos=Pos-1
		Forever
	EndIf
	
End Function
;UMBENENNEN
Function LAMA_IRename$(Path$)
	
	Local Copy=2
	If FileType(Path$)=0 Then Return Path$
	Local OnlyName$=LAMA_IFileName$(Path$,1)
	Local OnlyEnding$=LAMA_IFileName$(Path$,2)
	Local OnlyPath$=LAMA_IFileName$(Path$,3)
	Repeat
		Path$=OnlyPath$+OnlyName$+"("+Copy+")."+OnlyEnding
		If FileType(Path$)=1 Then
			Copy=Copy+1
		EndIf
		If FileType(Path$)=0 Then Return Path$
	Forever
	
End Function
Function LAMA_IRenameFolder$(Path$)
	
	Local Copy=2,NPath$
	If FileType(Path$)=0 Then Return Path$
	Repeat
		NPath=Path+"("+Copy+")"
		If FileType(NPath)=2 Then
			Copy=Copy+1
		EndIf
		If FileType(NPath)=0 Then Return NPath
	Forever
	
End Function
;ORDNER-INFOS
Function LAMA_ICreateMultiDir(Path$)
	
	Local FPos%
	Path=Replace(Path,LAMA_IFileName(Path),"")
	Path=Replace(Path,"/","\")
	If RSet(Path,1)="\" Then Path=Left(Path,Len(Path)-1)
	FPos=Instr(Path,"\")
	Repeat
		FPos=Instr(Path,"\",FPos+1)
		If FPos>0 Then
			If FileType(Left(Path,FPos-1))=0 Then
				CreateDir(Left(Path,FPos-1))
			EndIf
		Else
			CreateDir(Path)
		EndIf
		
		If FileType(Path)=2 Then Exit
	Forever
	
	
	Print Path
	
End Function
Function LAMA_ISendDir(PlayerID%,Path$,PPath$="")
	
	;variablen-vorbereiten
	Local Folder$
	Local FPath=ReadDir(Path)
	;daten-schreiben
	If PPath="" Then
		WriteByte LAMA_Stream,25;kennung
		WriteShort LAMA_Stream,LAMA_MasterID;von
		WriteShort LAMA_Stream,PlayerID;an
		WriteString LAMA_Stream,LAMA_IFolderName(Path)
	EndIf
	;senden
	Repeat
		Folder=NextFile$(FPath)
		If Folder="" Then Exit
		If FileType(Path+"\"+Folder)=2 And Folder<>"." And Folder<>".." Then
			If PPath="" Then PPath=Path
			LAMA_ISendDir(PlayerID,Path+"\"+Folder,PPath)
		Else If FileType(Path+"\"+Folder)=1 And Folder<>"." And Folder<>".." And Lower(Folder)<>"thumbs.db" Then
			
			LAMA_F.LAMA_FTr=New LAMA_FTr
			LAMA_F\Stream=ReadFile(Path+"\"+Folder)
			If PPath<>"" Then
				LAMA_F\Path=Replace(Path+"\"+Folder,PPath,"")
			Else
				LAMA_F\Path=Path+"\"+Folder
			EndIf
			LAMA_F\Mode=LAMA_FSend
			LAMA_F\P_ID=PlayerID
			LAMA_F\Byt=FileSize(Path+"\"+Folder)
			LAMA_T_ID=(LAMA_T_ID+1) Mod 65535
			LAMA_F\T_ID=LAMA_T_ID+1
			
			WriteByte LAMA_Stream,True;aktiv
			;daten-schreiben
			WriteShort LAMA_Stream,LAMA_F\T_ID;transferid
			WriteInt LAMA_Stream,LAMA_F\Byt;gesamt-bytes
			WriteString LAMA_Stream,LAMA_F\Path;dateiname
			
			LAMA_F\Path=PPath+LAMA_F\Path
		EndIf
	Forever
	;pfad-schlieen
	CloseDir CurrentDir()
	
End Function
Function LAMA_IRecvDir(PPath$)
	
	;variablen-vorbereiten
	Local Path$
	;senden
	While ReadByte(LAMA_Stream)=True
		CreateDir(PPath$+ReadString(LAMA_Stream))
	Wend
	
End Function
;LAMA-BROADCASTING-BY-EINGEPROGGT-UND-BADDEATH
Function LAMA_UpdateBroadCast()
	Local index,LAMA_txt$,SubMask$
	Local IPs%=CountHostIPs(GetEnv("localhost"))
	Local path$=GetEnv("appdata")+"\"
	Local ipconfig,IPFound
	
	If LAMA_LocalMS=0 Then
		LAMA_B.LAMA_BC=New LAMA_BC
		LAMA_B\IP=LAMA_IIP("127.0.0.1")
		;LAMA_BroadCastIPs=LAMA_BroadCastIPs+1
		LAMA_LocalMS=MilliSecs()+2000
	EndIf
	If LAMA_LocalMS<MilliSecs() Then
		LAMA_BroadCast=True
	EndIf
	If LAMA_Casting=False Then
		If LAMA_CastDims=False Then
			Dim LAMA_IP%(IPs-1)
			Dim LAMA_DotIP$(IPs-1)
			For index=1 To IPs
				LAMA_IP(index-1)=HostIP(index)
				LAMA_DotIP(index-1)=DottedIP(HostIP(index))
			Next
			LAMA_CastDims=True
		EndIf
		
		If FileType(path+"ipconfig.txt")=1 Then DeleteFile(path+"ipconfig.txt")
		If FileType(path+"ipconfig.txt")=0 Then
			;DebugLog "datei existiert nicht mehr"
			ipconfig=WriteFile(path+"temp.bat")
			If ipconfig>0 Then
				;DebugLog "ipconfig erfolgreich geschrieben"
				WriteLine ipconfig,"ipconfig > "+Chr(34)+path+"ipconfig.txt"+Chr(34)
				CloseFile ipconfig
				LAMA_Shell(0,"open",path+"temp.bat","","",0)
				LAMA_Casting=True
			EndIf
		EndIf
	Else
		If FileType(path+"ipconfig.txt")=1 Then
			DebugLog "datei existiert nun"
			ipconfig=ReadFile(path+"ipconfig.txt")
			For index=1 To IPs
				;DebugLog "auslesen"
				While Not Eof(ipconfig)
					LAMA_txt=ReadLine(ipconfig)
					If Instr(LAMA_txt,LAMA_DotIP$(index-1)) Then
						LAMA_txt=ReadLine(ipconfig)
						SubMask=Trim(Mid(LAMA_txt,Instr(LAMA_txt,":")+1,-1))
						CountHostIPs(SubMask)
						DebugLog "-----> BroadcastIP hinzufgen!"
						LAMA_B.LAMA_BC=New LAMA_BC
						LAMA_B\IP=LAMA_IIP(LAMA_IP(index-1) Or (~HostIP(1)))
						LAMA_BroadCastIPs=LAMA_BroadCastIPs+1
						IPFound=True
					EndIf
				Wend
				SeekFile ipconfig,0
			Next
			CloseFile ipconfig
			
			If IPFound=False Then
				;LAMA_Casting=False
			Else
				LAMA_BroadCast=True
			EndIf
			
			DeleteFile path$+"temp.bat"
			DeleteFile path$+"ipconfig.txt"
		Else
			;DebugLog "datei existiert noch nicht"
		EndIf
	EndIf
	
End Function
Function LAMA_IIP%(IP$)
	Local P1=Instr(IP$,".")
	Local P2=Instr(IP$,".",P1+1)
	Local P3=Instr(IP$,".",P2+1)
	Return (Int(Mid(IP$,1,P1))*16777216)+(Int(Mid(IP$,P1+1,P2-P1))*65536)+(Int(Mid(IP$,P2+1,P3-P2))*256)+Int(Mid(IP$,P3+1,-1))
End Function
;MD5-HASH-BY-CHESTER
Function SetBit(bank,offset)
	Local pos = Floor(offset / 8.0)
	Local old_byte = PeekByte(bank,pos)
	Local local_pos = offset Mod 8
	Local i
	
	Local new_byte
	Local bit[7]
	
	For i=7 To 0 Step -1
		If old_byte - (2^i) >= 0 Then bit[7-i] = 1 : old_byte = old_byte - (2^i)
	Next
	
	bit[local_pos] = 1
	
	For i = 7 To 0 Step -1
		If bit[7-i] = 1 Then new_byte = new_byte + (2^i)
	Next
	
	PokeByte(bank,pos,new_byte)
End Function
Function MD5$(my_string$)
	Local output$
	
	;Lnge des Strings in Bit
	Local bit_lenght = (Len(my_string)*8)
	
	;Bankgre in Bit, es gilt: (Stringlnge - 64) MOD 512 = 0
	Local bank_size = Ceil((bit_lenght+65) / 512.0) * 512
	
	;Speicherbank erstellen
	Local md5_bank = CreateBank(Ceil(bank_size / 8.0))
	
	;Laufvariablen
	Local l,j,i
	
	;Anzahl der 512-Bit Blocks
	Local blocks = bank_size/512
	
	;String in Bank speichern
	For l=1 To Len(my_string)
		PokeByte(md5_bank,l-1,Asc(Mid(my_string,l,1)))
	Next
	
	; Konstanten
	Local h0% = $67452301
	Local h1% = $EFCDAB89
	Local h2% = $98BADCFE
	Local h3% = $10325476
	
	Local A% = h0
	Local B% = h1
	Local C% = h2
	Local D% = h3
	
	;-----------------------------------
	; Konstanten zuweisen
	;-----------------------------------
	Local R[63],k[63]
	
	R[0] = 7:R[1] = 12:R[2] = 17:R[3] = 22:R[4] = 7:R[5] = 12:R[6] = 17:R[7] = 22
	R[8] = 7:R[9] = 12:R[10] = 17:R[11] = 22:R[12] = 7:R[13] = 12:R[14] = 17:R[15] = 22
	R[16] = 5:R[17] = 9:R[18] = 14:R[19] = 20:R[20] = 5:R[21] = 9:R[22] = 14:R[23] = 20
	R[24] = 5:R[25] = 9:R[26] = 14:R[27] = 20:R[28] = 5:R[29] = 9:R[30] = 14:R[31] = 20
	R[32]= 4:R[33]= 11:R[34]= 16:R[35]= 23:R[36]= 4:R[37]= 11:R[38]= 16:R[39]= 23
	R[40]= 4:R[41]= 11:R[42]= 16:R[43]= 23:R[44]= 4:R[45]= 11:R[46]= 16:R[47]= 23
	R[48] = 6:R[49] = 10:R[50] = 15:R[51] = 21:R[52] = 6:R[53] = 10:R[54] = 15:R[55] = 21
	R[56] = 6:R[57] = 10:R[58] = 15:R[59] = 21:R[60] = 6:R[61] = 10:R[62] = 15:R[63] = 21
	
	k[0] = $d76aa478:k[1] = $e8c7b756:k[2] = $242070db:k[3] = $c1bdceee:k[4] = $f57c0faf:k[5] = $4787c62a
	k[6] = $a8304613:k[7] = $fd469501:k[8] = $698098d8:k[9] = $8b44f7af:k[10] = $ffff5bb1:k[11] = $895cd7be
	k[12] = $6b901122:k[13] = $fd987193:k[14] = $a679438e:k[15] = $49b40821:k[16] = $f61e2562:k[17] = $c040b340
	k[18] = $265e5a51:k[19] = $e9b6c7aa:k[20] = $d62f105d:k[21] = $2441453:k[22] = $d8a1e681:k[23] = $e7d3fbc8
	k[24] = $21e1cde6:k[25] = $c33707d6:k[26] = $f4d50d87:k[27] = $455a14ed:k[28] = $a9e3e905:k[29] = $fcefa3f8
	k[30] = $676f02d9:k[31] = $8d2a4c8a:k[32] = $fffa3942:k[33] = $8771f681:k[34] = $6d9d6122:k[35] = $fde5380c
	k[36] = $a4beea44:k[37] = $4bdecfa9:k[38] = $f6bb4b60:k[39] = $bebfbc70:k[40] = $289b7ec6:k[41] = $eaa127fa
	k[42] = $d4ef3085:k[43] = $4881d05:k[44] = $d9d4d039:k[45] = $e6db99e5:k[46] = $1fa27cf8:k[47] = $c4ac5665
	k[48] = $f4292244:k[49] = $432aff97:k[50] = $ab9423a7:k[51] = $fc93a039:k[52] = $655b59c3:k[53] = $8f0ccc92
	k[54] = $ffeff47d:k[55] = $85845dd1:k[56] = $6fa87e4f:k[57] = $fe2ce6e0:k[58] = $a3014314:k[59] = $4e0811a1
	k[60] = $f7537e82:k[61] = $bd3af235:k[62] = $2ad7d2bb:k[63] = $eb86d391
	
	;-----------------------------------
	
	
	;ein gesetztes Bit an String anhngen
	SetBit(md5_bank, Len(my_string)*8)
	
	
	;-----------------------------------
	;Lnge des Strings anhngen:
	;-----------------------------------
	
	Local strlenght[64]
	Local num,bit64[63]
	
	num=Len(my_string)*8
	
	;Zahl in Bits speichern
	For i=63 To 0 Step -1
		If num - Int(2^i) >= 0 Then bit64[63-i] = 1 : num = num - Int(2^i)
	Next
	
	;Zahl in 64-Bit Little Endian konvertieren
	l=0
	For i=63 To 0 Step -8
		For j=0 To 7
			If bit64[i-7+j]=1 Then strlenght[l] = 1
			l =l + 1
		Next
	Next
	
	;Zahl anhngen
	For l=0 To 63
		If strlenght[l] Then
			SetBit(md5_bank,bank_size-64+l)
		EndIf
	Next
	
	;-----------------------------------
	; MD5
	;-----------------------------------
	
	;alle Blocks durchgehen
	For i=1 To blocks
		
		;Blocks in 16x 32-Bit Teile unterteilen
		Local parts[15]
		For j=0 To 15
			parts[j] = PeekInt(md5_bank,(i-1)*64+j*4)
		Next
		
		
		
		
		; Anfangsbelegung
		A% = h0
		B% = h1
		C% = h2
		D% = h3
		
		Local f,g
		For l=0 To 63
			If l >= 0 And l <=15 Then
			;Runde 1
				f = (B And C) Or ((~B) And D)
				g = l
			ElseIf l >= 16 And l <=31 Then
			;Runde 2
				f = (D And B) Or ((~D) And C)
				g = (l*5 + 1) Mod 16
			ElseIf l >= 32 And l <=47 Then
			;Runde 3
				f = B Xor C Xor D
				g = (l*3 + 5) Mod 16
			ElseIf l >= 48 And l <=63 Then
			;Runde 4
				f = C Xor (B Or (~D))
				g = (l*7) Mod 16
			EndIf
			
			;Verschiebung/Linksrotation
			Local temp = D
			D = C
			C = B
			B=(((A + f + k[l] + parts[g]) Shl  R[l]) Or ((A + f + k[l] + parts[g]) Shr (32 -  R[l]))) + B
			A = temp
		Next
		
		; Werte aller Blocks werden addiert
		h0 = h0 + A
		h1 = h1 + B
		h2 = h2 + C
		h3 = h3 + D
	Next
	
	
	
	;-----------------------------------
	;16-Bit Word in 128-Bit Hexcode
	;-----------------------------------
	Local tmp
	
	For i=0 To 3
		Select i
			Case 0 : tmp = h0
			Case 1 : tmp = h1
			Case 2 : tmp = h2
			Case 3 : tmp = h3
		End Select
		
		output = output +  Right(Hex((tmp And $FF)),2)
		output = output +  Right(Hex((tmp And $FF00)/$100),2)
		output = output +  Right(Hex((tmp And $FF0000)/$10000),2)
		output = output +  Right(Hex((tmp And $FF000000)/$1000000),2)
	Next
	
	;Rckgabe
	Return Lower(output)
End Function
;ENDE

;~IDEal Editor Parameters:
;~F#98#A1#A6#AD#B3#B9#C3#CA#D0#D7#DF#E5#EC#F9#2BB#2C8#2FA#30A#31A#332
;~F#346#35A#360#386#406#41D#422#431#43E#446#458#45F#46D#472#477#47C#48D#490#497#4A0
;~F#4A8#4B0#4B9#4C3#4E5#50E#527#52F#537#53F#547#553#55B#565#573#580#599#5AF#5D3#5D8
;~F#5DD#636#69D#6E4#769#7B2#7BA#7C2#7C8#7D0#7D8#7DF#7E6#7FD#804#80D#81D#85A#871#896
;~F#89E#8A6#8C4#8D3#8DD#906#90E#919#923#93F#950#960#96E#986#9B5#9C0#A0B#A12#A27
;~C#Blitz3D